F000 00 NOP
F001 11 ???
F002 A9 ???
F003 FC  CRC
F004 B4 
F005 0A RETS

F006 8C BR    @>F5BD        SBA 406 [= TRAP 16]
     F5                     SR 2012:= SR 2009 + SR 2012
     BD

F009 8C BR    @>F5BB        SBA 409
     F5                     SR 2012:= SR 2009 - SR 2012
     BB

F00C 8C BR    @>F68E        SBA 40C [= TRAP 14]
     F6                     SR 2012:= SR 2009 * SR 2012
     8E

F00F 8C BR    @>F77E        SBA 40F [= TRAP 17]
     F7                     SR 2012:= SR 2009 / SR 2012
     7E

F012 8C BR    @>F5B4        SBA 412
     F5                     SR 2012:= SR 2009 y^x SR 2012
     B4

F015 8C BR    @>F5AD        SBA 415
     F5                     SR 2012:= SR 2009 INV y^x SR 2012
     AD

F018 8C BR    @>F697        SBA 418
     F6                     Clear SR 2012
     97

F01B 8C BR    @>F768        SBA 41B
     F7                     Put +/- 9.9999999999999E+127 in SR 2012
     68

F01E 8C BR    @>F827        SBA 41E
     F8                     Swap SR 2009 and SR 2012
     27

F021 8C BR    @>F8AF        SBA 421
     F8                     Move SR 2012 to SR 2009
     AF

F024 8C BR    @>F83B        SBA 424
     F8                     Convert FP in SR 2012 to normalised FP
     3B

F027 8C BR    @>F8A3        SBA 427 [= TRAP 9]
     F8                     Move 8 bytes pointed to by R70/71 into SR 2009
     A3

F02A 8C BR    @>F8C2        SBA 42A [= TRAP 10]
     F8                     Push SR 2012 onto the FP stack
     C2

F02D 8C BR    @>F922        SBA 42D [= TRAP 11]
     F9                     Pop the FP stack into SR 2009
     22

F030 8C BR    @>F889        SBA 430
     F8                     Polynomial evaluator I
     89

F033 8C BR    @>F8F1        SBA 433
     F8                     Pop the FP stack into SR 2012
     F1

F036 8C BR    @>F65C        SBA 436
     F6
     5C

F039 8C BR    @>F638        SBA 439
     F6                     Propagate rounding through SR 2012
     38

F03C 8C BR    @>F92E        SBA 43C
     F9                     Floating point compare
     2E                     Result: SR 2009 >= SR 2012: C = 1
                                    SR 2009 <  SR 2012: N = 1
                                    SR 2009 =  SR 2012: Z = 1

F03F 8C BR    @>F553        SBA 43F
     F5                     Convert STD in SR 2007 to FP in SR 2012
     53

F042 8C BR    @>F4DE        SBA 442
     F4                     Convert FP in SR 2012 to STD in SR 2007
     DE

F045 8C BR    @>F395        SBA 445
     F3
     95

F048 8C BR    @>F3DD        SBA 448
     F3
     DD

F04B 8C BR    @>F40F        SBA 44B
     F4                     Find address of MSB of normal register
     0F

F04E 8C BR    @>F447        SBA 44E
     F4                     Find address of MSB of system register
     47

F051 8C BR    @>F98B        SBA 451 [= TRAP 8]
     F9                     Move block
     8B                     Source     : R80/81  Decremented
                            Destination: R82/83 
                            # of bytes : R84/85

F054 8C BR    @>F34A        SBA 454 [= TRAP 15]
     F3                     Call routine and return to calling SYS page
     4A

F057 8C BR    @>FF1A        SBA 457
     FF                     Fetch code at RUN PC and increment RUN PC,
     1A                     set flag 71 if RUN PC out of range

F05A 8C BR    @>FF43        SBA 45A
     FF                     Scan for (a) specific key(s) to be pressed
     43                     A: Row(s) to be scanned
                            B: Column(s) to be scanned

F05D 8C BR    @>F55B        SBA 45D
     F5                     Convert STD to FP
     5B                     STD source    : R84/85
                            FP destination: R86/87

F060 8C BR    @>F48C        SBA 460
     F4                     Convert a 4 digit BCD number to binary
     8C                     This routine may generate an error if the decimal
                            number contains non-BCB digits.

F063 8C BR    @>F546        SBA 463
     F5                     Convert a byte in A to decimal
     46

F066 8C BR    @>F9AF        SBA 466
     F9                     Master I/O routine
     AF                     R72/73: Address of devicecode of PAB

F069 8C BR    @>FE55        SBA 469
     FE                     Search for a label
     55

F06C 8C BR    @>FEB2        SBA 46C
     FE                     Insert a NOP at the current PC
     B2

F06F 8C BR    @>FECB        SBA 46F
     FE                     Delete the instruction at the current PC
     CB

F072 8C BR    @>F4BB        SBA 472
     F4
     BB

F075 8C BR    @>F2B5        SBA 475
     F2                     Execute SBA nxx, n in R91 and xx in R92
     B5

F078 8C BR    @>FFAD        SBA 478
     FF                     Errorhandler
     AD

F07B 8C BR    @>F12F        SBA 47B
     F1                     Main keystroke interpreter
     2F

F07E 8C BR    @>F378        SBA 47E
     F3                     Increment SYS PC, change SYS page and load code
     78                     at new PC

F081 8C BR    @>F383        SBA 481
     F3                     Restore the system SBR stack
     83

F084 8C BR    @>FF54        SBA 484
     FF                     Scan (a) specific column(s) of the keyboard
     54                     B: Column(s) to be scanned

F087 8C BR    @>F253        SBA 487
     F2                     Execute a special function depending on the value
     53                     in A. The special functions are:
                            A: 00 - Errorhandler  12 - RD
                               03 - PUT           15 - WRT
                               06 - GET           18 - VFY
                               09 - NAM           1B - SELFTESTS: menu
                               0C - DF            1E - PAR
                               0F - SHW

F08A 8C BR    @>F2BF        SBA 48A
     F2                     Convert ROM address + SYS page to SYS PC
     BF

F08D 8C BR    @>F32F        SBA 48D [= TRAP 7]
     F3                     Execute SBA nxx, n in A and xx in B
     2F                     [n can only be 1, 2 or 3]

F090 8C BR    @>F0FA        SBA 490 [= TRAP 0]
     F0                     Perform the ON function
     FA

F093 8C BR    @>FF3B        SBA 493
     FF                     Start the timer and wait for an interrupt
     3B

F096 8C BR    @>F99E        SBA 496
     F9                     Move block
     9E                     Source     : R80/81  Incremented
                            Destination: R82/83 
                            # of bytes : R84/85

F099 8C BR    @>F9A3        SBA 499
     F9                     Clear block
     A3                     Top of block: R82/83  Decremented
                            # of bytes  : R84/85 

F09C 8C BR    @>FEFD        SBA 49C
     FE                     Load the mnemonic of the instructioncode in R69
     FD                     into SR 2012

F09F 8C BR    @>FB03        SBA 49F
     FB                     Enable the cassette motor
     03

F0A2 8C BR    @>FB0B        SBA 4A2
     FB                     Disable the cassette motor
     0B

F0A5 8C BR    @>FF6A        SBA 4A5
     FF
     6A

F0A8 8C BR    @>FBFD        SBA 4A8
     FB
     FD

F0AB 8C BR    @>FB2E        SBA 4AB
     FB
     2E

F0AE 8C BR    @>FBF8        SBA 4AE
     FB
     F8

F0B1 8C BR    @>F8BC        SBA 4B1
     F8                     Push SR 2009 onto the FP stack
     BC

F0B4 8C BR    @>F8DB        SBA 4B4
     F8                     Swap SR 2012 and the FP stack
     DB

F0B7 8C BR    @>F89B        SBA 4B7
     F8                     Polynomial evaluator II
     9B

F0BA 8C BR    @>F0BD        SBA 4BA
     F0
     BD

SBA 4BA

F0BD A4 ORP   %>03,P6
     03
     06
F0C0 52 MOV   %>0F,B
     0F
F0C2 A2 MOVP  %>02,P15
     02
     0F
F0C5 A4 ORP   %>01,P15
     01
     0F
F0C8 92 MOVP  B,P14
     0E
F0CA A3 ANDP  %>0E,P15
     0E
     0F
F0CD A2 MOVP  %>00,P15
     00
     0F
F0D0 C2 DEC   B
F0D1 E3 JC    EF            [F0C2]
     EF
F0D3 A3 ANDP  %>FD,P6
     FD
     06
F0D6 88 MOVD  %>3FFF,R97
     3F
     FF
     61
F0DA 12 MOV   R97,A
     61
F0DC B4 INV   A
F0DD 9B STA   *R97
     61
F0DF DB DECD  R97
     61
F0E1 76 BTJO  %>20,R96,F5   [F0DA]
     20
     60
     F5
F0E5 88 MOVD  %>EFFF,R97
     EF
     FF
     61
F0E9 88 MOVD  %>AFFF,R99
     AF
     FF
     63
F0ED 9A LDA   *R97
     61
F0EF DB DECD  R97
     61
F0F1 DB DECD  R99
     63
F0F3 E3 JC    F8            [F0ED]
     F8
F0F5 A3 ANDP  %>FC,P6
     FC
     06
F0F8 E0 JMP   C3            [F0BD]
     C3

SBA 490/TRAP 0  [ON]

F0FA A4 ORP   %>04,P6
     04
     06
F0FD 22 MOV   %>AA,A
     AA
F0FF 8B STA   @>0100
     01
     00
F102 A2 MOVP  %>38,P24      Enable databus (bit 5 = 1)
     38                     Switch over to slow mode (bit 4 = 1)
     18                     Set clock divider value to 9 (8 + 1)
F105 52 MOV   %>01,B        Move 1 to B
     01
F107 0D LDSP                Load the stackpointer
F108 A3 ANDP  %>FC,P6       Select syspage 0
     FC
     06
F10B 8A LDA   @>BFFE        Load the byte at >BFFE into A
     BF
     FE
F10E C0 MOV   A,B           Store it in B
F10F B5 CLR   A             Clear A
F110 8B STA   @>BFFE        Store A at >BFFE
     BF
     FE
F113 22 MOV   %>97,A        Store >97 in A
     97
F115 8D CMPA  @>BFFF        Compare A to >BFFF
     BF
     FF
F118 E6 JNE   09            [F123]
     09
F11A B4 INV   A             Invert A (A  69)
F11B 6D CMP   B,A           Compare B to A
F11C E6 JNE   05            [F123]
     05
F11E 8A LDA   @>BFFE        Load the byte at >BFFE into A again
     BF
     FE
F121 E6 JNZ   9A            [F0BD]
     9A
F123 62 MOV   B,A           Move B back to A
F124 8B STA   @>BFFE        Restore >BFFE to its original value, to
     BF                     prevent alteration of RAM cartridges
     FE
F127 8E CALL  @>F52E        Clear SR 2007
     F5
     2E
F12A 88 MOVD  %>0300,R1     SBA 300
     03                     Main initialization
     00
     01
F12E F8 TRAP7

SBA 47B
This SBA is the main keystroke interpreter of the TI-95

F12F 88 MOVD  %>0226,R1     SBA 226
     02                     Pause without delay
     26
     01
F133 F8 TRAP7
F134 88 MOVD  %>0236,R1     SBA 236
     02                     Wait for key
     36
     01
F138 F8 TRAP7
F139 72 MOV   %>20,R50      Reset flags 80, 81, 82, 83, 84, 86 and 87,
     20                     set flag 85
     32
F13C 77 BTJZ  %>10,R47,0D   [F14D] Test if flag 60 is reset
     10
     2F
     0D
F140 72 MOV   %>0C,R66
     0C
     42
F143 88 MOVD  %>021C,R1     SBA 21C
     02                     Convert scancode to ASCII or 0 at >2107
     1C
     01
F147 F8 TRAP7
F148 12 MOV   R37,A         Store keycode into A
     25
F14A C1 TSTB
F14B E6 JNZ   32            [F17F] B <> 0?, ASCII code
     32
F14D 88 MOVD  %>C000,R90    Initialize R89/90 for first part of function
     C0                     table, containing information for the normal
     00                     functions
     5A
F151 12 MOV   R37,A         Get code of last key
     25
F153 E5 JPZ   0D            [F162] Positive or zero?, no 2nd function
     0D
F155 23 AND   %>7F,A        Clear MSB, to reduce value to >00 - >3F
     7F
F157 88 MOVD  %>C0C0,R90    Initialize R89/90 for second part of function
     C0                     table, containing information for the 2nd
     C0                     functions
     5A
F15B 2D CMP   %>35,A        Test if 'INV' pressed
     35
F15D E2 JEQ   03            [F162] Do not clear 2nd indicator if 'INV'
     03                     was pressed
F15F 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
F162 C0 MOV   A,B
F163 2D CMP   %>35,A        Test for 'INV' pressed
     35
F165 E2 JEQ   07            [F16E] Do not test for '+' if 'INV' was
     07                     pressed
F167 2D CMP   %>0A,A        Test for '+'
     0A
F169 E2 JEQ   03            [F16E] Do not reset flag 50 if '+' was
     03                     pressed
F16B 73 AND   %>FB,R46      If not '+', reset flag 50
     FB
     2E
F16E 68 ADD   B,A           Add B to A  (A  2A)
F16F 68 ADD   B,A           Add B to A  (A  3A)
F170 48 ADD   R0,R90        Add A to R90
     00
     5A
F173 79 ADC   %>00,R89      Add possible carry to R89
     00
     59
F176 8E CALL  @>F2DD        Get typebyte [R66] and
     F2                      - jumpaddress     [R91/92] or  [Type 01/02]
     DD                      - instructioncode [R91]        [Type 08/0C]
F179 77 BTJZ  %>08,R66,75   [F1F2] Test for type >01, SBA or
     08                                          >02, ROM keystroke
     42
     75
F17D 12 MOV   R91,A         Instructioncode for type
     5B
F17F D0 MOV   A,R36
     24
F181 77 BTJZ  %>20,R48,2B   [F1B0] Test if flag 69 is reset
     20
     30
     2B
F185 77 BTJZ  %>04,R66,07   [F190]
     04
     42
     07
F189 88 MOVD  %>0248,R1     SBA 248
     02                     Enter a non-field instruction in programmemory
     48
     01
F18D F8 TRAP7
F18E E0 JMP   9F            [F12F] Jump to the begin of the main keystroke
     9F                            interpreter loop

F190 8D CMPA  @>205C        FLDRAM
     20
     5C
F193 E7 JL    1B            [F1B0]
     1B
F195 88 MOVD  %>0252,R1     SBA 252
     02                     Enter a field instruction in programmemory
     52
     01
F199 E0 JMP   F2            [F18D]
     F2

The following code constitutes the ROM keystroke interpreter loop

F19B 73 AND   %>FB,R43      Reset flag 26
     FB
     2B
F19E 74 OR    %>08,R43      Set flag 27
     08
     2B
F1A1 9A LDA   *R39          Load code internal ROM program
     27
F1A3 D0 MOV   A,R36         Store at last key location
     24
F1A5 8A LDA   @>205F        Load the system subroutine counter
     20
     5F
F1A8 28 ADD   %>02,A        Add a level
     02
F1AA 8B STA   @>205F        Store back
     20
     5F
F1AD 8E CALL  @>F383        SBA 481
     F3                     Restore the system SBR stack
     83
F1B0 88 MOVD  %>0101,R1     Values to scan for OFF
     01
     01
     01
F1B4 8E CALL  @>FF43        SBA 45A
     FF                     Scan for (a) specific key(s) to be pressed
     43
F1B7 E6 JNZ   50            [F209]
     50
F1B9 12 MOV   R36,A
     24
F1BB 8E CALL  @>F2D1
     F2
     D1
F1BE 76 BTJO  %>08,R43,30   [F1F2] Test if flag 27 is set
     08
     2B
     30
F1C2 42 MOV   R66,R50
     42
     32
F1C5 73 AND   %>F8,R50      Reset flags 80, 81 and 82
     F8
     32
F1C8 78 ADD   %>04,R90       Increment pointer with 4
     04                      
     5A                      
F1CB 79 ADC   %>00,R89       
     00                      
     59                     
F1CE 9A LDA   *R90          Load 3rd character of mnemonic
     5A
F1D0 8B STA   @>2051        Store at trace location
     20
     51
F1D3 DB DECD  R90           Decrement pointer
     5A
F1D5 9A LDA   *R90          Load 2nd character of mnemonic
     5A
F1D7 8B STA   @>2052        Store at trace location
     20
     52
F1DA DB DECD  R90           Decrement pointer
     5A
F1DC 9A LDA   *R90          Load 1st character of mnemonic
     5A
F1DE 8B STA   @>2053        Store at trace location
     20
     53
F1E1 D8 PUSH  R66
     42
F1E3 D8 PUSH  R92
     5C
F1E5 D8 PUSH  R91
     5B
F1E7 88 MOVD  %>0114,R1     SBA 114
     01
     14
     01
F1EB F8 TRAP7
F1EC D9 POP   R91
     5B
F1EE D9 POP   R92
     5C
F1F0 D9 POP   R66
     42
F1F2 76 BTJO  %>01,R66,18   [F20E] Type >01?, execute SBA
     01
     42
     18
F1F6 73 AND   %>EF,R46      Reset flag 52
     EF
     2E
F1F9 77 BTJZ  %>40,R44,03   [F200] Test if flag 38 is reset
     40
     2C
     03
F1FD 74 OR    %>10,R46      Set flag 52
     10
     2E
F200 F3 TRAP12              Reset flags 35, 37, 38 and 59
F201 98 MOVD  R92,R39
     5C
     27
F204 8E CALL  @>F2FD        Map the SYS PC to the ROM address and page
     F2
     FD
F207 E0 JMP   92            [F19B]
     92

F209 88 MOVD  %>0358,R1     SBA 358
     03                     Turn off the TI-95
     58
     01
F20D F8 TRAP7

F20E 8E CALL  @>F2B5        SBA 475
     F2                     Execute SBA nxx, n in R91 and xx in R92
     B5
F211 8A LDA   @>205F        Load system subroutine counter
     20
     5F
F214 E2 JZ    1F            [F235] Zero?, end of ROM program
     1F
F216 2A SUB   %>02,A        Lower one level
     02
F218 8B STA   @>205F        Store back
     20
     5F
F21B C0 MOV   A,B           Use current level as pointer
F21C AA LDA   @>2041(B)     Load LSB of return address
     20
     41
F21F D0 MOV   A,R39         Move to LSB of SYS PC
     27
F221 AA LDA   @>2040(B)     Load MSB of return address
     20
     40
F224 D0 MOV   A,R38         Move to MSB of SYS PC
     26
F226 76 BTJO  %>04,R43,05   [F22F] Test if flag 26 is set. This flag is set
     04                            at >D888 [Page 3]. It indicates that a
     2B                            GTO or SBR has been executed.
     05
F22A D3 INC   R39            Increment SYS PC
     27                      
F22C 79 ADC   %>00,R38       
     00                      
     26                     
F22F 8E CALL  @>F2FD        Map the SYS PC to the ROM address and page
     F2
     FD
F232 8C BR    @>F19B        Jump to the begin of the begin of the ROM
     F1                     keystroke interpreter loop
     9B

F235 73 AND   %>F7,R43      Reset flag 27
     F7
     2B
F238 76 BTJO  %>FF,R111,0C  [F248] Test if an error has occurred
     FF
     6F
     0C
F23C 88 MOVD  %>0116,R1     SBA 116
     01
     16
     01
F240 F8 TRAP7
F241 76 BTJO  %>70,R43,1D   [F262] Test if flag 28, 29 or 30 is set
     70
     2B
     1D
F245 8C BR    @>F12F        SBA 47B
     F1                     Main keystroke interpreter
     2F

F248 12 MOV   R111,A        Get system error code
     6F
F24A 8B STA   @>2094        Store at error location
     20
     94
F24D D5 CLR   R111          Clear system error code
     6F
F24F 73 AND   %>7F,R43      Reset flag 31
     7F
     2B
F252 B5 CLR   A

SBA 487
This SBA is used to perform 11 special functions, depending on the value in A.
The functions are:

A: 00 - Errorhandler
   03 - PUT
   06 - GET
   09 - NAM
   0C - DF
   0F - SHW
   12 - RD
   15 - WRT
   18 - VFY
   1B - SELFTESTS: menu
   1E - PAR

F253 88 MOVD  %>C780,R90    Special functions
     C7
     80
     5A
F257 48 ADD   R0,R90         Increment pointer to selected function
     00                      
     5A                      
F25A 79 ADC   %>00,R89       
     00                      
     59                     
F25D 8E CALL  @>F2DD
     F2
     DD
F260 E0 JMP   90            [F1F2]
     90

F262 76 BTJO  %>68,R44,2D   [F293] Test if flag 35, 37 or 38 is set
     68
     2C
     2D
F266 76 BTJO  %>18,R47,29   [F293] Test if flag 59 or 60 is set
     18
     2F
     29
F26A 88 MOVD  %>0256,R1     SBA 256
     02                     Update the indicators
     56
     01
F26E F8 TRAP7
F26F 76 BTJO  %>80,R43,20   [F293] Test if flag 31 is set
     80
     2B
     20
F273 76 BTJO  %>80,R45,1C   [F293] Test if flag 47 is set
     80
     2D
     1C
F277 76 BTJO  %>04,R46,18   [F293] Test if flag 50 is set
     04
     2E
     18
F27B 88 MOVD  %>0201,R1     Values to scan for BREAK
     02
     01
     01
F27F 72 MOV   %>0A,R36
     0A
     24
F282 8E CALL  @>FF43        SBA 45A
     FF                     Scan for (a) specific key(s) to be pressed
     43
F285 E6 JNZ   26            [F2AD]
     26
F287 88 MOVD  %>0202,R1     Values to scan for HALT
     02
     02
     01
F28B 72 MOV   %>09,R36
     09
     24
F28E 8E CALL  @>FF43        SBA 45A
     FF                     Scan for (a) specific key(s) to be pressed
     43
F291 E6 JNZ   1A            [F2AD]
     1A
F293 8E CALL  @>FF6A        SBA 4A5
     FF
     6A
F296 8E CALL  @>FF1A        SBA 457
     FF                     Fetch code at RUN PC and increment RUN PC,
     1A                     set flag 71 if RUN PC out of range
F299 76 BTJO  %>80,R48,15   [F2B2] Test if flag 71 is set
     80
     30
     15
F29D D0 MOV   A,R36
     24
F29F 2D CMP   %>05,A        Compare with 'INV'
     05
F2A1 E2 JEQ   07            [F2AA]
     07
F2A3 2D CMP   %>13,A        Compare with '+'
     13
F2A5 E2 JEQ   03            [F2AA]
     03
F2A7 73 AND   %>FB,R46      Reset flag 50
     FB
     2E
F2AA 8C BR    @>F1B0
     F1
     B0

F2AD 73 AND   %>7F,R46      Reset flag 55
     7F
     2E
F2B0 E0 JMP   F8            [F2AA]
     F8

F2B2 22 MOV   %>08,A        Errormessage: INVALID ADDRESS
     08
F2B4 F9 TRAP6

SBA 475
This SBA is used to execute all SBAs

F2B5 32 MOV   R91,B         First digit of SBA
     5B
F2B7 5D CMP   %>07,B        Compare with 7
     07
F2B9 E3 JHS   60            [F31B] If >= 7: ILLEGAL FIELD
     60
F2BB CE RL    B             Multiply by 2
F2BC AC BR    @>F31E(B)     Branch to series of jumps
     F3
     1E

SBA 48A
This SBA is used to convert an absolute PC + page to a SYS PC

F2BF 77 BTJZ  %>80,R38,0D   [F2D0] Test if MSB of SYS PC < 7F
     80
     26
     0D
F2C3 7A SUB   %>C0,R38
     C0
     26
F2C6 8A LDA   @>205E        Load the current SYS PAGE
     20
     5E
F2C9 E2 JZ    05            [F2D0] Current SYS PAGE 0?, return
     05
F2CB 78 ADD   %>20,R38
     20
     26
F2CE BA DJNZ  A,FB          [F2CB]
     FB
F2D0 0A RETS

F2D1 2C MPY   %>06,A        Multiply instructioncode by 6
     06
F2D3 88 MOVD  %>C180,R90    Base address of function table
     C1
     80
     5A
F2D7 48 ADD   R1,R90         Add offset to base address
     01                      
     5A                      
F2DA 49 ADC   R0,R89        
     00
     59
F2DD A3 ANDP  %>FC,P6       Select syspage 0
     FC
     06
F2E0 9A LDA   *R90          Load type byte
     5A
F2E2 D0 MOV   A,R66         Store in R66
     42
F2E4 27 BTJZ  %>02,A,05     [F2EC] Test if 1st bit of type is zero
     02                            Bits: 76543210
     05
F2E7 88 MOVD  %>0208,R1     SBA 208
     02                     Calculate the exponent
     08
     01
F2EB F8 TRAP7
F2EC 78 ADD   %>02,R90      Add two to table address
     02
     5A
F2EF 79 ADC   %>00,R89      Correct for carry
     00
     59
F2F2 9A LDA   *R90          Load LSB of jumpaddress
     5A
F2F4 D0 MOV   A,R92
     5C
F2F6 DB DECD  R90           Decrement table address
     5A
F2F8 9A LDA   *R90          Load MSB of jumpaddress
     5A
F2FA D0 MOV   A,R91
     5B
F2FC 0A RETS

The following routine (>F2FD to >F31A) maps the SYS PC used in the keystroke
programmed functions to the correct addresses in the ROM.

The relation between keystroke PC and ROM address is:

Keystoke PC  ROM address
0000..1FFF   C000..DFFF   Page 0
2000..3FFF   C000..DFFF   Page 1
4000..5FFF   C000..DFFF   Page 2  Not used
6000..7FFF   C000..DFFF   Page 3  
8000..FFFF   8000..FFFF   Page 0 

F2FD 8A LDA   @>205E        Load current SYS PAGE
     20
     5E
F300 76 BTJO  %>80,R38,08   [F30C] Test if most significant bit of
     80                     MSB of SYS PC is one
     26
     08
F304 B5 CLR   A             Set SYS PAGE to 0
F305 76 BTJO  %>E0,R38,0C   [F315] Test if MSB of SYS PC is in
     E0                     range 20 - FF
     26
     0C
F309 78 ADD   %>C0,R38      Add C0 to MSB of syspc
     C0
     26
F30C A3 ANDP  %>FC,P6       Set SYS PAGE to 0
     FC
     06
F30F 84 ORP   A,P6          Set SYS PAGE to value in A
     06
F311 8B STA   @>205E        Store SYS PAGE back
     20
     5E
F314 0A RETS

F315 B3 INC   A             Increment SYS PAGE
F316 7A SUB   %>20,R38      Subtract 20 from MSB of SYS PC
     20
     26
F319 E0 JMP   EA            [F305]
     EA

F31B 22 MOV   %>07,A        Errormessage: ILLEGAL FIELD
     07
F31D F9 TRAP6
F31E E0 JMP   FB            [F31B]  SBA 0xx
     FB
F320 E0 JMP   0A            [F32C]  SBA 1xx
     0A
F322 E0 JMP   08            [F32C]  SBA 2xx
     08
F324 E0 JMP   06            [F32C]  SBA 3xx
     06
F326 E0 JMP   2B            [F353]  SBA 4xx
     2B
F328 E0 JMP   36            [F360]  SBA 5xx
     36
F32A E0 JMP   46            [F372]  SBA 6xx
     46
F32C 98 MOVD  R92,R1        Store SBA nxx in A (n) and B (xx)
     5C
     01

SBA 48D/TRAP 7
This SBA/TRAP is used to execute SBAs in the 1xx, 2xx and 3xx range

F32F C8 PUSH  B             Save B
F330 91 MOVP  P6,B          Get current syspage
     06
F332 A3 ANDP  %>FC,P6       Select syspage 0
     FC
     06
F335 84 ORP   A,P6          Select SYS PAGE based on 1st digit of SBA
     06
F337 62 MOV   B,A           Move previous syspage to A
F338 C9 POP   B             Get offset in pointertable
F339 B8 PUSH  A             Save previous syspage on stack
F33A AA LDA   @>C012(B)     Load MSB of address
     C0
     12
F33D D0 MOV   A,R70
     46
F33F AA LDA   @>C013(B)     Load LSB of address
     C0
     13
F342 D0 MOV   A,R71
     47
F344 9E CALL  *R71          Call routine
     47
F346 B9 POP   A             Return previous syspage to A
F347 82 MOVP  A,P6          Restore previous syspage
     06
F349 0A RETS                Return to caller

SBA 454/TRAP 15
This SBA/TRAP is used to execute those functions that may change the current
SYS PAGE. By saving the current SYS PAGE and restoring it after the call it
prevents returns to the wrong SYS PAGE.

F34A 91 MOVP  P6,B          Get current syspage
     06
F34C C8 PUSH  B             Save on stack
F34D 9E CALL  *R71          Call routine
     47
F34F C9 POP   B             Get saved syspage back from stack
F350 92 MOVP  B,P6          Restore syspage
     06
F352 0A RETS                Return to caller

SBA 4xx's are handled in this section

F353 88 MOVD  %>F000,R1     Move starting address to A, B
     F0
     00
     01
F357 38 ADD   R92,B         Add xx to B
     5C
F359 29 ADC   %>00,A        Adjust A (???)
     00
F35B 9C BR    *R1           Branch to routine (RETS at end of routine
     01                     will return to caller)

SBA 5xx's are handled in this section

F35D 22 MOV   %>06,A        Errormessage: INVALID SEQUENCE
     06
F35F F9 TRAP6
F360 77 BTJZ  %>40,R43,F9   [F35D] Test if flag 30 is reset
     40
     2B
     F9
F364 32 MOV   R92,B
     5C
F366 AA LDA   @>4000(B)     Load MSB of address
     40
     00
F369 D0 MOV   A,R70
     46
F36B AA LDA   @>4001(B)     Load LSB of address
     40
     01
F36E D0 MOV   A,R71
     47
F370 9C BR    *R71          Branch to routine (RETS at end of routine
     47                     will return to caller)

SBA 6xx's are handled in this section

F372 88 MOVD  %>034E,R1     SBA 34E
     03                     Execute SBA 6--
     4E
     01
F376 E0 JMP   B7            [F32F]
     B7

SBA 47E
This SBA is used to increment the SYS PC. After incrementing it, the [new] SYS
PAGE is determined and the code at the SYS PC is loaded.

F378 D3 INC   R39            Increment SYS PC
     27                      
F37A 79 ADC   %>00,R38       
     00                      
     26                     
F37D 8E CALL  @>F2FD        Map the SYS PC to the ROM address and page
     F2
     FD
F380 9A LDA   *R39          Load code at SYS PC
     27
F382 0A RETS

SBA 481
This routine is used to "restore" the system SBR stack after the
SYS PC has been modified by the execution of RCA =, MRG = and
DFN {Fx} CLR instructions or by SBA 38E.

F383 8E CALL  @>F2BF        SBA 48A
     F2                     Convert ROM address + SYS page to SYS PC
     BF
F386 8A LDA   @>205F        Load system SBR counter
     20
     5F
F389 C0 MOV   A,B           Use as pointer
F38A 12 MOV   R38,A         Load MSB of SYS PC
     26
F38C AB STA   @>203E(B)     Store in system SBR stack
     20
     3E
F38F 12 MOV   R39,A         Load LSB of SYS PC
     27
F391 AB STA   @>203F(B)     Store in system SBR stack
     20
     3F
F394 0A RETS

SBA 445

F395 8E CALL  @>F2FD        Map the SYS PC to the ROM address and page
     F2
     FD
F398 8A LDA   @>20AC
     20
     AC
F39B C0 MOV   A,B
F39C D3 INC   R39            Increment SYS PC
     27                      
F39E 79 ADC   %>00,R38       
     00                      
     26                     
F3A1 9A LDA   *R39          Load code at SYS PC
     27
F3A3 2D CMP   %>F8,A        Compare with 'IND'
     F8
F3A5 E6 JNE   0A            [F3B1] Code was not equal 'IND'
     0A
F3A7 57 BTJZ  %>40,B,07     [F3B1]
     40
     07
F3AA 74 OR    %>10,R44      Set flag 36
     10
     2C
F3AD 52 MOV   %>0B,B
     0B
F3AF E0 JMP   EB            [F39C]
     EB

F3B1 57 BTJZ  %>08,B,0F     [F3C3]
     08
     0F
F3B4 2D CMP   %>41,A        Compare with 'A'
     41
F3B6 E7 JL    0B            [F3C3] Code < 'A', no alpha addressing
     0B
F3B8 2D CMP   %>5B,A        Compare with '[', first character after 'Z'
     5B
F3BA E3 JHS   07            [F3C3] Code > 'Z', no alpha addressing
     07
F3BC 2A SUB   %>41,A        Subtract >41 from A, to convert A to 00 - 25
     41
F3BE 8E CALL  @>F546        SBA 463
     F5                     Convert a byte in A to decimal
     46
F3C1 E0 JMP   10            [F3D3]
     10

F3C3 53 AND   %>07,B
     07
F3C5 5D CMP   %>03,B
     03
F3C7 E7 JL    0A            [F3D3]
     0A
F3C9 8B STA   @>21AB
     21
     AB
F3CC D3 INC   R39           Increment LSB of SYS PC
     27
F3CE 79 ADC   %>00,R38      Increment MSB of SYS PC
     00
     26
F3D1 9A LDA   *R39          Load code at SYS PC
     27
F3D3 8B STA   @>21AC        Store at LSB of registernumber location
     21
     AC
F3D6 8E CALL  @>F383        SBA 481
     F3                     Restore the system SBR stack
     83
F3D9 77 BTJZ  %>10,R44,66   [F443] Test if flag 36 is reset
     10
     2C
     66

SBA 448

F3DD 8A LDA   @>21AB        Load MSB of register number
     21
     AB
F3E0 C0 MOV   A,B           Move to B
F3E1 23 AND   %>0F,A        Clear first 4 bits of register, reducing
     0F                     it to range 00 - 09
F3E3 8B STA   @>21AB        Store it back
     21
     AB
F3E6 53 AND   %>F0,B        If the registernumber starts with 0x, we
     F0                     deal with a normal register
F3E8 E2 JZ    13            [F3FD] Routine for normal registers
     13
F3EA 5D CMP   %>30,B        If the registernumber starts with 0x or
     30                     2x, we deal with a direct recall
F3EC E7 JL    03            [F3F1]
     03
F3EE 74 OR    %>01,R44      Set flag 32 [Indicates IND(?)]
     01
     2C
F3F1 5D CMP   %>20,B        If the register starts with 20, we deal
     20                     with a systemregister
F3F3 E2 JEQ   15            [F40A] Retrieve address of MSB of systemregister
     15
F3F5 5D CMP   %>30,B        Systemregister containing number of other
     30                     systemregister
F3F7 E2 JEQ   11            [F40A] Retrieve address of MSB of systemregister
     11
F3F9 5D CMP   %>60,B        Normal register containing number of
     60                     systemregister
F3FB E6 JNE   47            [F444] None of the above: INVALID REGISTER
     47
F3FD 8E CALL  @>F40F        SBA 44B
     F4                     Find address of MSB of normal register
     0F
F400 88 MOVD  %>21AF,R83    Set destination for register to be recalled
     21
     AF
     53
F404 98 MOVD  R71,R81       Initialize from-address
     47
     51
F407 8C BR    @>F97F        Block move routine
     F9
     7F

F40A 8E CALL  @>F447        SBA 44E
     F4                     Find address of MSB of system register
     47
F40D E0 JMP   F1            [F400]
     F1

SBA 44B
Retrieve address of MSB of normal register

F40F 22 MOV   %>09,A        Code for possible errormessage
     09
F411 8B STA   @>2105        Store at temporary location
     21
     05
F414 8E CALL  @>F48C        SBA 460
     F4                     Convert a 4 digit BCD number to binary
     8C
F417 8A LDA   @>20B1        Max # of registers (LSB)
     20
     B1
F41A C0 MOV   A,B           Move to B
F41B 8A LDA   @>20B0        Max # of registers (MSB)
     20
     B0
F41E CB DECD  B             Decrement with 1
F41F E7 JNC   23            [F444] No registers, give INVALID REGISTER
     23
F421 3A SUB   R65,B         Subtract R65 from B
     41
F423 1B SBB   R64,A         Subtract R64 from A
     40
F425 E7 JNC   1D            [F444] Requested register not available,
     1D                     give INVALID REGISTER
F427 52 MOV   %>03,B         Multiply R64/65 by 8 (2^3)
     03                      
F429 48 ADD   R65,R65        
     41                      
     41                      
F42C 49 ADC   R64,R64        
     40                      
     40                      
F42F CA DJNZ  B,F8           [F429]
     F8
F431 88 MOVD  %>3FFF,R1     End of registerarea
     3F
     FF
     01
F435 3A SUB   R65,B         Subtract R65 from B
     41
F437 1B SBB   R64,A         Subtract R64 from A
     40
F439 98 MOVD  R1,R71        Store resulting address of MSB of
     01                     requested register in R70/71
     47
F43C 8B STA   @>2096         Save resulting address also at
     20                        >2096 (MSB) and >2097 (LSB)
     96                      
F43F 62 MOV   B,A            
F440 8B STA   @>2097         
     20                      
     97                     
F443 0A RETS

F444 22 MOV   %>09,A        Errormessage: INVALID REGISTER
     09
F446 F9 TRAP6

SBA 44E
Retrieve address of MSB of systemregister

F447 22 MOV   %>09,A        Code for possible errormessage
     09
F449 8B STA   @>2105        Store at temporary location
     21
     05
F44C 8E CALL  @>F48C        SBA 460
     F4                     Convert a 4 digit BCD number to binary
     8C
F44F 52 MOV   %>03,B         Multiply R64/65 by 8 (2^3)
     03                      
F451 48 ADD   R65,R65        
     41                      
     41                      
F454 49 ADC   R64,R64        
     40                      
     40                      
F457 CA DJNZ  B,F8           [F451]
     F8
F459 78 ADD   %>07,R65      Add 7 to obtain address of MSB of
     07                     systemregister
     41
F45C 88 MOVD  %>007F,R1     Address of MSB of SR 2015
     00
     7F
     01
F460 3A SUB   R65,B         Subtract obtained address from >007F, to
     41                     check if requested systemregister > 15
F462 1B SBB   R64,A
     40
F464 E7 JNC   05            [F46B] Requested systemregister > 15
     05
F466 98 MOVD  R65,R1        Store R64/65 in R00/R01
     41
     01
F469 E0 JMP   CE            [F439] Common segment for all recall
     CE                     functions

F46B 88 MOVD  %>1F80,R1     Requested systemregister > 15. Adding of
     1F                     >1F80 will bring address in the correct
     80                     range
     01
F46F 48 ADD   R1,R65        Add constant to obtained address, to
     01                     find real address
     41
F472 49 ADC   R0,R64
     00
     40
F475 E3 JC    CD            [F444] Requested systemregister > 528,
     CD                     errormessage: INVALID REGISTER
F477 88 MOVD  %>23E0,R1     Address of begin of file space
     23
     E0
     01
F47B 3A SUB   R65,B         Subtract real address of constant, to
     41                     check for values between 16 - 139
F47D 1B SBB   R64,A
     40
F47F E7 JNC   C3            [F444] Requested systemregister > 139,
     C3                     errormessage: INVALID REGISTER
F481 E0 JMP   E3            [F466] Common segment for recalls of
     E3                     systemregisters

F483 D5 CLR   R64
     40
F485 D5 CLR   R65
     41
F487 8A LDA   @>2105        Get error code back to A
     21
     05
F48A F9 TRAP6               Generate error
F48B 0A RETS

SBA 460
This SBA is used to convert a 4 digit decimal number to binary. If the number
contains non-BCD data, an error may be generated.

Input:
>21AB: MSB of decimal number
>21AC: LSB of decimal number
>2105: Errorcode if error is to be generated

Output:
R64: MSB of converted number
R65: LSB of converted number

If the input contains non-BCD data, zeroes will be returned in R64/65 and an
error is generated if >2105 contains a non-zero value

F48C 8A LDA   @>21AB        Get first two decimal digits
     21
     AB
F48F 8E CALL  @>F4A4        Routine to check if A contains a valid
     F4                     BCD coded value. Converts A to binary if
     A4                     valid, otherwise it generates an error
F492 2C MPY   %>64,A        Multiply by >64 (=100 decimal)
     64
F494 98 MOVD  R1,R65        Move to R64 (MSB) - R65 (LSB)
     01
     41
F497 8A LDA   @>21AC        Get next two decimal digits
     21
     AC
F49A 8E CALL  @>F4A4        Routine to check if A contains a valid
     F4                     BCD coded value. Converts A to binary if
     A4                     valid, otherwise it generates an error
F49D 48 ADD   R0,R65        Add result to LSB
     00
     41
F4A0 79 ADC   %>00,R64      Correct MSB
     00
     40
F4A3 0A RETS

This routine is used to generate an error if a byte that should contain
only BCD values contains hexadecimal values. If it is OK, the routine
continues into a routine that converts the byte to its hexadecimal
equivalent.

F4A4 2D CMP   %>A0,A        Compare A to >A0
     A0
F4A6 E3 JHS   DB            [F483] Generate an error if A is greater
     DB                     than or equal to >A0
F4A8 B7 SWAP  A             Swap the first 4 bits of a with the last 4
F4A9 2D CMP   %>A0,A        Compare A to >A0
     A0
F4AB E3 JHS   D6            [F483] Generate an error if A is greater
     D6                     than or equal to >A0
F4AD B7 SWAP  A             Restore A to its original value

The following routine converts a BCD byte in A to its hexadecimal
equivalent.

F4AE C0 MOV   A,B           Move A to B
F4AF 23 AND   %>0F,A        Clear the first 4 bits of A
     0F
F4B1 C7 SWAP  B             Swap the first 4 bits of B with the last 4
F4B2 53 AND   %>0F,B        Clear the first 4 bits of B
     0F
F4B4 E2 JZ    04            [F4BA] If the resulting B is zero, we are
     04                     ready
F4B6 28 ADD   %>0A,A        Add 10 to A
     0A
F4B8 CA DJNZ  B,FC          [F4B6] Repeat for all B
     FC
F4BA 0A RETS

SBA 472

F4BB 8A LDA   @>20AC
     20
     AC
F4BE 23 AND   %>07,A
     07
F4C0 D0 MOV   A,R64
     40
F4C2 8E CALL  @>F378        SBA 47E
     F3                     Increment SYS PC, change SYS page and load code
     78                     at new PC
F4C5 C5 CLR   B
F4C6 2D CMP   %>F8,A
     F8
F4C8 E6 JNE   0B            [F4D5]
     0B
F4CA 8C BR    @>F3AA
     F3
     AA

F4CD D3 INC   R39            Increment SYS PC
     27                      
F4CF 79 ADC   %>00,R38       
     00                      
     26                     
F4D2 9A LDA   *R39          Load code at SYS PC
     27
F4D4 C3 INC   B             Increment pointer
F4D5 AB STA   @>21A8(B)     Store at fields location
     21
     A8
F4D8 DA DJNZ  R64,F2        [F4CD] Repeat for entire field
     40
     F2
F4DB 8C BR    @>F3D6
     F3
     D6

SBA 442
Convert a floating point number in SR 2012 to standard notation

F4DE D5 CLR   R80           Eventually R80 will contain the sign
     50
F4E0 12 MOV   R97,A         Get MSB of floating point number
     61
F4E2 E2 JZ    4A            [F52E] Zero?, clear the display
     4A
F4E4 12 MOV   R96,A         Get the exponent
     60
F4E6 E5 JPZ   04            [F4EC] Positive or zero?, the mantissa
     04                     is positive
F4E8 B4 INV   A             Invert the exponent
F4E9 74 OR    %>04,R80      2nd bit of sign byte 1, negative mantissa
     04
     50
F4EC 2A SUB   %>40,A        Subtract >40 from exponent
     40                     [Pos: 00-31, Neg: FF-CE]
F4EE E3 JC    09            [F4F9] Result > 0?, positive exponent
     09
F4F0 74 OR    %>08,R80      3rd bit of sign byte 1, negative exponent
     08
     50
F4F3 B4 INV   A             Invert the exponent [Neg: 00-31]
F4F4 76 BTJO  %>F0,R97,01   [F4F9] Test if the first nibble of the floating
     F0                     point number <> 0
     61
     01
F4F8 B3 INC   A             Increment the exponent [Neg: 01-32]
F4F9 BE RL    A             Multiply by 2
F4FA B3 INC   A             Increment the exponent
F4FB 76 BTJO  %>F0,R97,06   [F505] Test if the first nibble of the floating
     F0                     point number <> 0
     61
     06
F4FF B2 DEC   A             Decrement the exponent
F500 B8 PUSH  A             Save it
F501 8E CALL  @>F83B        SBA 424
     F8                     Convert FP in SR 2012 to normalised FP
     3B
F504 B9 POP   A             Get exponent back
F505 2D CMP   %>64,A        Compare it with 100
     64
F507 E3 JHS   21            [F52A] Generate overflow if > 99
     21
F509 8E CALL  @>F546        SBA 463
     F5                     Convert a byte in A to decimal
     46
F50C D0 MOV   A,R56         Move it to the exponent field of display
     38
F50E 42 MOV   R97,R63        Move SR 2012 to rest of display
     61                      
     3F                      
F511 42 MOV   R98,R62        
     62                      
     3E                      
F514 42 MOV   R99,R61        
     63                      
     3D                      
F517 42 MOV   R100,R60       
     64                      
     3C                      
F51A 42 MOV   R101,R59       
     65                      
     3B                      
F51D 42 MOV   R102,R58       
     66                      
     3A                      
F520 42 MOV   R103,R57       
     67                      
     39                     
F523 73 AND   %>F0,R57      Clear sign information
     F0
     39
F526 48 ADD   R80,R57       Add sign information
     50
     39
F529 0A RETS

F52A 77 BTJZ  %>08,R80,09   [F537] Generate overflow if the sign of the
     08                     exponent is positive, treat underflow as 0
     50
     09

The following routine clears the display

F52E B5 CLR   A             Clear A
F52F 52 MOV   %>08,B        # of bytes to clear
     08
F531 AB STA   @>0037(B)     Clear B'th position of display
     00
     37
F534 CA DJNZ  B,FB          [F531] Repeat for entire display
     FB
F536 0A RETS

F537 72 MOV   %>01,R111     Errorcode 1, OVERFLOW
     01
     6F
F53A 22 MOV   %>99,A        Value to put in display
     99
F53C 8E CALL  @>F52F        Fill entire display with 9s
     F5
     2F
F53F 73 AND   %>F0,R57      Clear the sign information
     F0
     39
F542 48 ADD   R80,R57       Add the signinformation
     50
     39
F545 0A RETS

SBA 463
Convert a byte to its BCD equivalent

F546 C5 CLR   B             B is used to build the BCD equivalent
F547 2A SUB   %>0A,A        Subtract >A from A
     0A
F549 E7 JNC   04            [F54F] If result < 0, A was in range 0 - 9
     04
F54B 58 ADD   %>10,B        Add 10 to B, building the BCD equivalent
     10
F54D E0 JMP   F8            [F547] Next subtraction
     F8

F54F 28 ADD   %>0A,A        Add >A to A, to restore value of A to 0 - 9
     0A
F551 68 ADD   B,A           Add B to A, to obtain the BCD equivalent
F552 0A RETS

SBA 43F
Convert a number in the display register to floating point in SR 2012

F553 88 MOVD  %>0038,R85    Address of exponent
     00
     38
     55
F557 88 MOVD  %>0060,R87    Address of floating point exponent
     00
     60
     57

SBA 45D
Convert a standard number to floating point
The result of the conversion of the number <a.bcdefghijklm Exy> is
dependent on the signs of the mantissa and exponent parts, and also
on the fact of the exponent is odd or even.
The resulting number is in one of the next two formats:

 - lmjkhifgdebc0aXY if the exponent is even
 - m0klijghefcdbaXY if the exponent is odd

The original exponent <xy> is converted to its binary equivalent <XY>,
and it can have an offset of 40 or C0, depending on the sign of the
mantissa. The results can be summarized in the following table:

    Ŀ
     Sign-        Range of  Resulting 
     digit  M  E  exponent    value   
    Ĵ
       0    +  +  +0 - +99   40 - 71  
       4    -  +  +0 - +99   BF - 8E  
       8    +  -  -1 - -99   3F - 0E  
       C    -  -  -1 - -99   C0 - F1  
    

F55B 9A LDA   *R85          Load the exponent
     55
F55D D0 MOV   A,R80         Move the exponent to R80
     50
F55F 8E CALL  @>F4AE        This routine converts the BCD exponent
     F4                     to its binary equivalent
     AE
F562 C0 MOV   A,B           Store A in B
F563 D3 INC   R85           Increment the address
     55
F565 9A LDA   *R85          Load the 13th digit/sign byte
     55
F567 B6 XCHB  A             Swap A and B
F568 57 BTJZ  %>08,B,03     [F56E] Skip the next 3 instructions if the
     08                     exponent was positive (C  0)
     03
F56B B4 INV   A             Invert A
F56C B3 INC   A             Add 1, to create a 2s complement value
F56D 07 SETC                Set the carry, to assure the MSB of A remains 1
F56E BD RRC   A             Divide A by 2
F56F 28 ADD   %>40,A        Add >40 to A
     40
F571 57 BTJZ  %>04,B,01     [F575] Skip the next instruction if the
     04                     number was positive
     01
F574 B4 INV   A             Invert A
F575 9B STA   *R87          Store A in the LSB of 8-byte destination
     57
F577 78 ADD   %>07,R87      Add 7 to pint to the MSB
     07
     57
F57A 62 MOV   B,A           Get the 13th digit/sign byte back to A
F57B 72 MOV   %>07,R82      Set up count for conversion
     07
     52
F57E 77 BTJZ  %>01,R80,0E   [F590] Jump to F590 if the exponent of
     01                     the number was even
     50
     0E
F582 23 AND   %>F0,A        Set the original sign bit to 0
     F0
F584 9B STA   *R87          Store the result at the address pointed
     57                     to by R86/87
F586 D3 INC   R85           Increment the pointer to the next byte
     55                     of the number to be converted
F588 DB DECD  R87           Decrement the destination address
     57
F58A 9A LDA   *R85          Get the next byte to be converted
     55
F58C DA DJNZ  R82,F5        [F584] Repeat until entire number is
     52                     converted
     F5
F58F 0A RETS

This routine is used to convert the mantissa of numbers with an exponent
that is even

F590 B7 SWAP  A             Put the signdigit in the first 4 bits of A
F591 B8 PUSH  A             Save A on the stack
F592 E0 JMP   0E            [F5A2] Skip the next 9 instructions on the
     0E                     first pass

F594 9A LDA   *R85          Get the next byte of the number to be
     55                     converted
F596 C9 POP   B             Get the previous byte back
F597 53 AND   %>0F,B        Clear the first 4 bits of B
     0F
F599 B7 SWAP  A             Swap the nibbles of A
F59A B8 PUSH  A             Save A on the stack
F59B 23 AND   %>F0,A        Clear the last four bits of A
     F0
F59D 68 ADD   B,A           Add the last 4 bits of B to the first 4 of A
F59E 9B STA   *R87          Store the result
     57
F5A0 DB DECD  R87           Decrement the destination address
     57
F5A2 D3 INC   R85           Increment the pointer to the next byte
     55                     of the number to be converted
F5A4 DA DJNZ  R82,ED        [F594] Repeat until entire number is
     52                     converted, but as the loop starts with
     ED                     this instruction, a half byte is left out
F5A7 B9 POP   A             Get the MSB back
F5A8 23 AND   %>0F,A        Clear the first 4 bits
     0F
F5AA 9B STA   *R87          Store it at location just before the
     57                     exponent
F5AC 0A RETS

SBA 415
This SBA performs the INV y^x function

F5AD 88 MOVD  %>0304,R1     SBA 304
     03                     Perform the INV y^x function
     04
     01
F5B1 8C BR    @>F32F
     F3
     2F

SBA 412
This SBA performs the y^x function

F5B4 88 MOVD  %>0302,R1     SBA 302
     03                     Perform the y^x function
     02
     01
F5B8 8C BR    @>F32F
     F3
     2F

SBA 409
This SBA performs the - function

F5BB D4 INV   R96           Change the sign of the mantissa of SR 2012
     60

SBA 406/TRAP 16
This SBA/TRAP performs the + function

F5BD 12 MOV   R73,A
     49
F5BF E2 JZ    07              [F5C8]
     07
F5C1 76 BTJO  %>FF,R97,04     [F5C9]
     FF
     61
     04
F5C5 8C BR    @>F827        SBA 41E
     F8                     Swap SR 2009 and SR 2012
     27

F5C8 0A RETS

F5C9 42 MOV   R72,R83
     48
     53
F5CC E5 JPZ   02            [F5D0]
     02
F5CE D4 INV   R72
     48
F5D0 45 XOR   R96,R83
     60
     53
F5D3 42 MOV   R96,R82
     60
     52
F5D6 E5 JPZ   02            [F5DA]
     02
F5D8 D4 INV   R96
     60
F5DA D5 CLR   R80
     50
F5DC D5 CLR   R104
     68
F5DE 52 MOV   %>F8,B
     F8
F5E0 AA LDA   @>FF68(B)
     FF
     68
F5E3 AD CMPA  @>FF50(B)
     FF
     50
F5E6 E6 JNE   05            [F5ED]
     05
F5E8 C3 INC   B
F5E9 E6 JNZ   F5            [F5E0]
     F5
F5EB E0 JMP   2C            [F619]
     2C

F5ED E3 JHS   06            [F5F5]
     06
F5EF 8E CALL  @>F829
     F8
     29
F5F2 45 XOR   R83,R82
     53
     52
F5F5 12 MOV   R96,A
     60
F5F7 1A SUB   R72,A
     48
F5F9 E2 JZ    1E            [F619]
     1E
F5FB 26 BTJO  %>78,A,53     [F651]
     78
     53
F5FE 88 MOVD  %>0050,R85
     00
     50
     55
F602 52 MOV   %>08,B
     08
F604 3A SUB   R0,B
     00
F606 AA LDA   @>0048(B)
     00
     48
F609 9B STA   *R85
     55
F60B D2 DEC   R85
     55
F60D CA DJNZ  B,F7          [F606]
     F7
F60F B5 CLR   A
F610 9B STA   *R85
     55
F612 D2 DEC   R85
     55
F614 7D CMP   %>48,R85
     48
     55
F617 E6 JNE   F7            [F610]
     F7
F619 76 BTJO  %>80,R83,3B   [F658]
     80
     53
     3B
F61D 8E CALL  @>F870
     F8
     70
F620 E7 JNC   0F            [F631]
     0F
F622 52 MOV   %>07,B
     07
F624 AA LDA   @>0060(B)
     00
     60
F627 AB STA   @>0061(B)
     00
     61
F62A CA DJNZ  B,F8          [F624]
     F8
F62C 72 MOV   %>01,R97
     01
     61
F62F D3 INC   R96
     60
F631 7D CMP   %>50,R104
     50
     68
F634 E7 JL    14            [F64A]
     14
F636 52 MOV   %>07,B
     07

SBA 439
Propagate rounding through SR 2012

F638 AA LDA   @>0060(B)
     00
     60
F63B 2E DAC   %>01,A
     01
F63D 0E PUSHST
F63E AB STA   @>0060(B)
     00
     60
F641 08 POPST
F642 E7 JNC   06            [F64A]
     06
F644 CA DJNZ  B,F2          [F638]
     F2
F646 D3 INC   R96
     60
F648 D3 INC   R97
     61
F64A 77 BTJZ  %>80,R96,03   [F651]
     80
     60
     03
F64E 8C BR    @>F768        SBA 41B
     F7                     Put +/- 9.9999999999999E+127 in SR 2012
     68

F651 77 BTJZ  %>80,R82,02   [F657]
     80
     52
     02
F655 D4 INV   R96
     60
F657 0A RETS

F658 07 SETC
F659 8E CALL  @>F857
     F8
     57

SBA 436

F65C 76 BTJO  %>FF,R97,D1   [F631]
     FF
     61
     D1
F660 52 MOV   %>01,B
     01
F662 AA LDA   @>0061(B)
     00
     61
F665 E6 JNZ   07            [F66E]
     07
F667 C3 INC   B
F668 57 BTJZ  %>08,B,F7     [F662]
     08
     F7
F66B D5 CLR   R96
     60
F66D 0A RETS

F66E 4A SUB   R1,R96
     01
     60
F671 E7 JNC   24            [F697]
     24
F673 88 MOVD  %>0061,R85
     00
     61
     55
F677 AA LDA   @>0061(B)
     00
     61
F67A 9B STA   *R85
     55
F67C D3 INC   R85
     55
F67E C3 INC   B
F67F 57 BTJZ  %>08,B,F5     [F677]
     08
     F5
F682 B5 CLR   A
F683 9B STA   *R85
     55
F685 D3 INC   R85
     55
F687 7D CMP   %>69,R85
     69
     55
F68A E7 JL    F7            [F683]
     F7
F68C E0 JMP   BC            [F64A]
     BC

SBA 40C/TRAP 14
This SBA/TRAP performs the * function

F68E 76 BTJO  %>FF,R97,01   [F693]
     FF
     61
     01
F692 0A RETS

F693 76 BTJO  %>FF,R73,09   [F6A0]
     FF
     49
     09

SBA 418
This SBA is used to clear SR 2012

F697 B5 CLR   A
F698 52 MOV   %>08,B
     08
F69A AB STA   @>005F(B)
     00
     5F
F69D CA DJNZ  B,FB          [F69A]
     FB
F69F 0A RETS

F6A0 D8 PUSH  R96
     60
F6A2 D8 PUSH  R72
     48
F6A4 8E CALL  @>F81E
     F8
     1E
F6A7 52 MOV   %>08,B
     08
F6A9 C2 DEC   B
F6AA AA LDA   @>0060(B)
     00
     60
F6AD E2 JZ    FA            [F6A9]
     FA
F6AF D1 MOV   B,R110
     6E
F6B1 72 MOV   %>01,R109
     01
     6D
F6B4 72 MOV   %>01,R107
     01
     6B
F6B7 32 MOV   R107,B
     6B
F6B9 AA LDA   @>0048(B)
     00
     48
F6BC E2 JZ    66            [F724]
     66
F6BE C0 MOV   A,B
F6BF 53 AND   %>0F,B
     0F
F6C1 B7 SWAP  A
F6C2 23 AND   %>0F,A
     0F
F6C4 98 MOVD  R1,R81
     01
     51
F6C7 D5 CLR   R96
     60
F6C9 32 MOV   R96,B
     60
F6CB AA LDA   @>0061(B)
     00
     61
F6CE E2 JZ    4B            [F71B]
     4B
F6D0 D0 MOV   A,R105
     69
F6D2 B7 SWAP  A
F6D3 23 AND   %>0F,A
     0F
F6D5 D0 MOV   A,R104
     68
F6D7 B5 CLR   A
F6D8 C5 CLR   B
F6D9 42 MOV   R81,R108
     51
     6C
F6DC E2 JZ    07            [F6E5]
     07
F6DE 3E DAC   R105,B
     69
F6E0 2E DAC   %>00,A
     00
F6E2 DA DJNZ  R108,F9       [F6DE]
     6C
     F9
F6E5 D7 SWAP  R105
     69
F6E7 73 AND   %>F0,R105
     F0
     69
F6EA 42 MOV   R80,R108
     50
     6C
F6ED E2 JZ    07            [F6F6]
     07
F6EF 3E DAC   R105,B
     69
F6F1 1E DAC   R104,A
     68
F6F3 DA DJNZ  R108,F9       [F6EF]
     6C
     F9
F6F6 98 MOVD  R1,R105
     01
     69
F6F9 32 MOV   R109,B
     6D
F6FB AA LDA   @>0052(B)
     00
     52
F6FE 1E DAC   R105,A
     69
F700 0E PUSHST
F701 AB STA   @>0052(B)
     00
     52
F704 AA LDA   @>0051(B)
     00
     51
F707 08 POPST
F708 1E DAC   R104,A
     68
F70A 0E PUSHST
F70B AB STA   @>0051(B)
     00
     51
F70E 08 POPST
F70F E7 JNC   0A            [F71B]
     0A
F711 C2 DEC   B
F712 E2 JZ    07            [F71B]
     07
F714 AA LDA   @>0051(B)
     00
     51
F717 2E DAC   %>01,A
     01
F719 E0 JMP   EF            [F70A]
     EF

F71B D3 INC   R109
     6D
F71D D3 INC   R96
     60
F71F 4D CMP   R96,R110
     60
     6E
F722 E4 JGT   A5            [F6C9]
     A5
F724 D3 INC   R107
     6B
F726 42 MOV   R107,R109
     6B
     6D
F729 77 BTJZ  %>08,R107,8A  [F6B7]
     08
     6B
     8A
F72D C9 POP   B
F72E D1 MOV   B,R105
     69
F730 E5 JPZ   01            [F733]
     01
F732 C4 INV   B
F733 B9 POP   A
F734 45 XOR   R0,R105
     00
     69
F737 B0 CLRC
F738 E5 JPZ   01            [F73B]
     01
F73A B4 INV   A
F73B 5A SUB   %>40,B
     40
F73D 68 ADD   B,A
F73E 88 MOVD  %>005A,R81
     00
     5A
     51
F742 7D CMP   %>00,R82
     00
     52
F745 E2 JEQ   03            [F74A]
     03
F747 D2 DEC   R81
     51
F749 B3 INC   A
F74A D0 MOV   A,R96
     60
F74C E5 JPZ   06            [F754]
     06
F74E 57 BTJZ  %>80,B,14     [F765]
     80
     14
F751 8C BR    @>F697        SBA 418
     F6                     Clear SR 2012
     97

F754 52 MOV   %>08,B
     08
F756 9A LDA   *R81
     51
F758 AB STA   @>0060(B)
     00
     60
F75B DB DECD  R81
     51
F75D CA DJNZ  B,F7          [F756]
     F7
F75F 42 MOV   R105,R82
     69
     52
F762 8C BR    @>F631
     F6
     31

F765 42 MOV   R105,R82
     69
     52

SBA 41B
This SBA puts the number +/- 9.9999999999999E+127 in SR 2012

F768 72 MOV   %>01,R111
     01
     6F
F76B 72 MOV   %>7F,R96
     7F
     60
F76E 77 BTJZ  %>80,R82,02   [F774]
     80
     52
     02
F772 D4 INV   R96
     60
F774 22 MOV   %>99,A
     99
F776 52 MOV   %>07,B
     07
F778 AB STA   @>0060(B)
     00
     60
F77B CA DJNZ  B,FB          [F778]
     FB
F77D 0A RETS

SBA 40F/TRAP 17
This SBA/TRAP performs the / function

F77E 8E CALL  @>F81E
     F8
     1E
F781 76 BTJO  %>FF,R97,05   [F78A]
     FF
     61
     05
F785 42 MOV   R72,R82
     48
     52
F788 E0 JMP   DE            [F768]
     DE

F78A 76 BTJO  %>FF,R73,03   [F791]
     FF
     49
     03
F78E 8C BR    @>F697        SBA 418
     F6                     Clear SR 2012
     97

F791 8E CALL  @>F827        SBA 41E
     F8                     Swap SR 2009 and SR 2012
     27
F794 12 MOV   R96,A
     60
F796 E5 JPZ   01            [F799]
     01
F798 B4 INV   A
F799 32 MOV   R72,B
     48
F79B E5 JPZ   01            [F79E]
     01
F79D C4 INV   B
F79E 45 XOR   R72,R96
     48
     60
F7A1 D8 PUSH  R96
     60
F7A3 5A SUB   %>40,B
     40
F7A5 6A SUB   B,A
F7A6 C4 INV   B
F7A7 C8 PUSH  B
F7A8 D0 MOV   A,R82
     52
F7AA D5 CLR   R96
     60
F7AC C5 CLR   B
F7AD C2 DEC   B
F7AE AA LDA   @>FF50(B)
     FF
     50
F7B1 E2 JZ    FA            [F7AD]
     FA
F7B3 C4 INV   B
F7B4 62 MOV   B,A
F7B5 68 ADD   B,A
F7B6 68 ADD   B,A
F7B7 D0 MOV   A,R95
     5F
F7B9 D5 CLR   R93
     5D
F7BB D5 CLR   R109
     6D
F7BD D5 CLR   R94
     5E
F7BF D7 SWAP  R94
     5E
F7C1 76 BTJO  %>FF,R97,1A   [F7DF]
     FF
     61
     1A
F7C5 76 BTJO  %>FF,R96,16   [F7DF]
     FF
     60
     16
F7C9 52 MOV   %>FA,B
     FA
F7CB AA LDA   @>FF68(B)
     FF
     68
F7CE E6 JNZ   22            [F7F2]
     22
F7D0 C3 INC   B
F7D1 E6 JNZ   F8            [F7CB]
     F8
F7D3 12 MOV   R94,A
     5E
F7D5 32 MOV   R109,B
     6D
F7D7 AB STA   @>0053(B)
     00
     53
F7DA 72 MOV   %>09,R109
     09
     6D
F7DD E0 JMP   27            [F806]
     27

F7DF 32 MOV   R95,B
     5F
F7E1 7E DAC   %>00,R94
     00
     5E
F7E4 07 SETC
F7E5 AE CALL  @>F85A(B)
     F8
     5A
F7E8 E3 JC    F7            [F7E1]
     F7
F7EA 7F DSB   %>00,R96
     00
     60
F7ED E3 JC    F2            [F7E1]
     F2
F7EF AE CALL  @>F873(B)
     F8
     73
F7F2 8E CALL  @>F83B        SBA 424
     F8                     Convert FP in SR 2012 to normalised FP
     3B
F7F5 D4 INV   R93
     5D
F7F7 E2 JZ    C6            [F7BF]
     C6
F7F9 12 MOV   R94,A
     5E
F7FB 32 MOV   R109,B
     6D
F7FD AB STA   @>0053(B)
     00
     53
F800 D3 INC   R109
     6D
F802 77 BTJZ  %>08,R109,B7  [F7BD]
     08
     6D
     B7
F806 88 MOVD  %>005A,R81
     00
     5A
     51
F80A 76 BTJO  %>FF,R83,08   [F816]
     FF
     53
     08
F80E 77 BTJZ  %>01,R109,AB  [F7BD]
     01
     6D
     AB
F812 D3 INC   R81
     51
F814 D2 DEC   R82
     52
F816 C9 POP   B
F817 D9 POP   R105
     69
F819 12 MOV   R82,A
     52
F81B 8C BR    @>F74A
     F7
     4A

F81E 52 MOV   %>0E,B
     0E
F820 B5 CLR   A
F821 AB STA   @>0051(B)
     00
     51
F824 CA DJNZ  B,FB          [F821]
     FB
F826 0A RETS

SBA 41E
Swap contents of SR 2009 and SR 2012

F827 52 MOV   %>F8,B        Number of bytes to swap, 8
     F8
F829 AA LDA   @>FF68(B)     Load byte from SR 2012
     FF
     68
F82C B8 PUSH  A             Save on stack
F82D AA LDA   @>FF50(B)     Load byte from SR 2009
     FF
     50
F830 AB STA   @>FF68(B)     Store in SR 2012
     FF
     68
F833 B9 POP   A             Get byte from SR 2012 from stack
F834 AB STA   @>FF50(B)     Store in SR 2009
     FF
     50
F837 C3 INC   B             Increment pointer
F838 E6 JNZ   EF            [F829] Loop until done
     EF
F83A 0A RETS

SBA 424
Convert a floating point number in SR 2012 to normalized
floating point notation
 Ŀ
  Register  67  66  65  64  63  62  61  60 
 Ĵ
  Before    ab  cd  ef  gh  ij  kl  pn  -- 
  After     b0  da  fc  he  jg  li  nk  0p 
 

F83B D5 CLR   R104          Temporary usage
     68
F83D 52 MOV   %>F9,B        Number of bytes to convert, 7
     F9
F83F AA LDA   @>FF68(B)     Load byte at address >0061 - >0067
     FF
     68
F842 B7 SWAP  A             Swap nibbles
F843 B8 PUSH  A             Save on stack
F844 23 AND   %>0F,A        Clear most significant nibble
     0F
F846 14 OR    R104,A        Store in R104
     68
F848 AB STA   @>FF67(B)     Store back at address >0060 - >0066
     FF
     67
F84B D9 POP   R104          Get byte back
     68
F84D 73 AND   %>F0,R104     Clear least significant nibble
     F0
     68
F850 C3 INC   B             Increment count
F851 E6 JNZ   EC            [F83F] Loop until done
     EC
F853 42 MOV   R104,R103     Move last least significant nibble to R67
     68
     67
F856 0A RETS

F857 4F DSB   R80,R104
     50
     68
F85A 4F DSB   R79,R103
     4F
     67
F85D 4F DSB   R78,R102
     4E
     66
F860 4F DSB   R77,R101
     4D
     65
F863 4F DSB   R76,R100
     4C
     64
F866 4F DSB   R75,R99
     4B
     63
F869 4F DSB   R74,R98
     4A
     62
F86C 4F DSB   R73,R97
     49
     61
F86F 0A RETS

F870 4E DAC   R80,R104
     50
     68
F873 4E DAC   R79,R103
     4F
     67
F876 4E DAC   R78,R102
     4E
     66
F879 4E DAC   R77,R101
     4D
     65
F87C 4E DAC   R76,R100
     4C
     64
F87F 4E DAC   R75,R99
     4B
     63
F882 4E DAC   R74,R98
     4A
     62
F885 4E DAC   R73,R97
     49
     61
F888 0A RETS

SBA 430
This routine calculates a polynomial of the type
A(n) * X^n + A(n-1) * X^(n-1) + ... + A(1) * X + A(0)

Input:
R70/71         : Address of LSB of A(n)
Top of FP stack: X
SR 2012        : X

Output:
SR 2012        : Value of polynomial for X [in FP format!]

Note:
 - The A(n) must be stored in FP format, with A(n) at the highest address in
   memory and with the LSB at the highest address. The byte following A(0) must
   contain >FF to signal the end

F889 F6 TRAP9               Move data addressed by R70/71 into SR 2009
F88A E0 JMP   0E            [F89A]
     0E

F88C 52 MOV   %>08,B        Number of bytes to move
     08
F88E 98 MOVD  R113,R85      Copy of top of FP stack
     71
     55
F891 9A LDA   *R85           Copy value at the top of the FP stack into
     55                        SR 2009
F893 AB STA   @>0047(B)      
     00                      
     47                      
F896 DB DECD  R85            
     55                      
F898 CA DJNZ  B,F7           [F891]
     F7
F89A F1 TRAP14              SR 2012:= SR 2009 * SR 2012

SBA 4B7
This routine calculates a polynomial of the type
X^n + A(n-1) * X^(n-1) + ... + A(1) * X + A(0)

The input and output for this routine are the same as those for SBA 430

F89B F6 TRAP9               Move data addressed by R70/71 into SR 2009
F89C EF TRAP16              SR 2012:= SR 2009 + SR 2012
F89D 9A LDA   *R71
     47
F89F 27 BTJZ  %>FF,A,EA     [F88C] Repeat until a separator byte is reached
     FF
     EA
F8A2 0A RETS

SBA 427/TRAP 9
Move 8 bytes pointed to by R70/71 into SR 2009

F8A3 52 MOV   %>08,B
     08
F8A5 9A LDA   *R71
     47
F8A7 AB STA   @>0047(B)
     00
     47
F8AA DB DECD  R71
     47
F8AC CA DJNZ  B,F7          [F8A5]
     F7
F8AE 0A RETS

SBA 421
Move SR 2012 to SR 2009

F8AF 98 MOVD  R97,R73
     61
     49
F8B2 98 MOVD  R99,R75
     63
     4B
F8B5 98 MOVD  R101,R77
     65
     4D
F8B8 98 MOVD  R103,R79
     67
     4F
F8BB 0A RETS

SBA 4B1
Push SR 2009 onto the FP stack

F8BC 88 MOVD  %>004F,R65
     00
     4F
     41
F8C0 E0 JMP   04            [F8C6]
     04

SBA 42A/TRAP 10
Push SR 2012 onto the FP stack

F8C2 88 MOVD  %>0067,R65
     00
     67
     41
F8C6 78 ADD   %>08,R113
     08
     71
F8C9 C8 PUSH  B
F8CA 52 MOV   %>08,B
     08
F8CC 9A LDA   *R65
     41
F8CE 9B STA   *R113
     71
F8D0 D2 DEC   R65
     41
F8D2 D2 DEC   R113
     71
F8D4 CA DJNZ  B,F6          [F8CC]
     F6
F8D6 78 ADD   %>08,R113
     08
     71
F8D9 C9 POP   B
F8DA 0A RETS

SBA 4B4
Swap SR 2012 with the FP stack

F8DB 52 MOV   %>08,B
     08
F8DD AA LDA   @>005F(B)
     00
     5F
F8E0 B8 PUSH  A
F8E1 9A LDA   *R113
     71
F8E3 AB STA   @>005F(B)
     00
     5F
F8E6 B9 POP   A
F8E7 9B STA   *R113
     71
F8E9 D2 DEC   R113
     71
F8EB CA DJNZ  B,F0          [F8DD]
     F0
F8ED 78 ADD   %>08,R113
     08
     71
F8F0 0A RETS

SBA 433
Pop the FP stack into SR 2012

F8F1 9A LDA   *R113
     71
F8F3 D0 MOV   A,R103
     67
F8F5 D2 DEC   R113
     71
F8F7 9A LDA   *R113
     71
F8F9 D0 MOV   A,R102
     66
F8FB D2 DEC   R113
     71
F8FD 9A LDA   *R113
     71
F8FF D0 MOV   A,R101
     65
F901 D2 DEC   R113
     71
F903 9A LDA   *R113
     71
F905 D0 MOV   A,R100
     64
F907 D2 DEC   R113
     71
F909 9A LDA   *R113
     71
F90B D0 MOV   A,R99
     63
F90D D2 DEC   R113
     71
F90F 9A LDA   *R113
     71
F911 D0 MOV   A,R98
     62
F913 D2 DEC   R113
     71
F915 9A LDA   *R113
     71
F917 D0 MOV   A,R97
     61
F919 D2 DEC   R113
     71
F91B 9A LDA   *R113
     71
F91D D0 MOV   A,R96
     60
F91F D2 DEC   R113
     71
F921 0A RETS

SBA 42D/TRAP 11
Pop the FP stack into SR 2009

F922 52 MOV   %>08,B        Number of bytes to move
     08
F924 9A LDA   *R113         Load source
     71
F926 AB STA   @>0047(B)     Store in register 2009
     00
     47
F929 DB DECD  R113          Decrement source pointer
     71
F92B CA DJNZ  B,F7          [F924] Repeat until done
     F7
F92D 0A RETS

SBA 43C
This SBA compares two floating point numbers in SR 2009 and SR 2012. The result
of the compare is returned in the statusbits.

Results: SR 2009 >= SR 2012: C = 1
         SR 2009 <  SR 2012: N = 1
         SR 2009 =  SR 2012: Z = 1

F92E 76 BTJO  %>FF,R73,05   [F937]
     FF
     49
     05
F932 88 MOVD  %>0306,R1     SBA 306
     03                     Clear SR 2009
     06
     01
F936 F8 TRAP7
F937 76 BTJO  %>FF,R97,03   [F93E]
     FF
     61
     03
F93B 8E CALL  @>F697        SBA 418
     F6                     Clear SR 2012
     97
F93E 12 MOV   R72,A
     48
F940 15 XOR   R96,A
     60
F942 E5 JPZ   08            [F94C]
     08
F944 76 BTJO  %>80,R72,03   [F94B]
     80
     48
     03
F948 22 MOV   %>02,A
     02
F94A B2 DEC   A
F94B 0A RETS

F94C 4D CMP   R96,R72
     60
     48
F94F E6 JNE   FA            [F94B]
     FA
F951 4D CMP   R97,R73
     61
     49
F954 E6 JNE   1E            [F974]
     1E
F956 4D CMP   R98,R74
     62
     4A
F959 E6 JNE   19            [F974]
     19
F95B 4D CMP   R99,R75
     63
     4B
F95E E6 JNE   14            [F974]
     14
F960 4D CMP   R100,R76
     64
     4C
F963 E6 JNE   0F            [F974]
     0F
F965 4D CMP   R101,R77
     65
     4D
F968 E6 JNE   0A            [F974]
     0A
F96A 4D CMP   R102,R78
     66
     4E
F96D E6 JNE   05            [F974]
     05
F96F 4D CMP   R103,R79
     67
     4F
F972 E2 JEQ   0A            [F97E]
     0A
F974 0E PUSHST
F975 77 BTJZ  %>80,R96,04   [F97D]
     80
     60
     04
F979 B9 POP   A
F97A 25 XOR   %>80,A
     80
F97C B8 PUSH  A
F97D 08 POPST
F97E 0A RETS

F97F 88 MOVD  %>0007,R85
     00
     07
     55

F983 9A LDA   *R81          Load from-address
     51
F985 9B STA   *R83          Move to to-address
     53
F987 DB DECD  R81           Decrement from-address
     51
F989 DB DECD  R83           Decrement to-address
     53

SBA 451/TRAP 8
This routine is used to move a block of memory to another location.
It uses the following registers:
  - R80/81: From-address  (Address is decremented)
  - R82/83: To-address        "     "      "
  - R84/85: Number of bytes to move

F98B DB DECD  R85           Decrement count
     55
F98D E3 JC    F4            [F983] Loop until done
     F4
F98F 0A RETS

F990 9A LDA   *R81          Load from-address
     51
F992 9B STA   *R83          Move to to-address
     53
F994 D3 INC   R81            Increment from-address
     51                      
F996 79 ADC   %>00,R80       
     00                      
     50                     
F999 D3 INC   R83            Increment to-address
     53                      
F99B 79 ADC   %>00,R82       
     00                      
     52                     

SBA 496
This routine is used to move a block of memory to another location.
It uses the following registers:
  - R80/81: From-address (Address is incremented)
  - R82/83: To-address       "     "      "
  - R84/85: Number of bytes to move

F99E DB DECD  R85           Decrement count
     55
F9A0 E3 JC    EE            [F990] Loop until done
     EE
F9A2 0A RETS

SBA 499
This routine is used to clear a block of memory, but it can also be
used to initialise a block of memory to a fixed value, by prestoring
this value in A, and entering the routine at >F9A4
It uses the following registers:
  - R82/83: Highest address to clear (Address is decremented)
  - R84/85: Number of bytes to clear

F9A3 B5 CLR   A
F9A4 E0 JMP   04            [F9AA] Correct for count
     04

F9A6 9B STA   *R83          Store A
     53
F9A8 DB DECD  R83           Decrement address to be cleared (or initialised)
     53
F9AA DB DECD  R85           Decrement count
     55
F9AC E3 JC    F8            [F9A6] Loop until done
     F8
F9AE 0A RETS

SBA 466
This SBA is used to perform standard I/O

F9AF 06 DINT
F9B0 80 MOVP  P15,A
     0F
F9B2 8B STA   @>22F8
     22
     F8
F9B5 80 MOVP  P14,A
     0E
F9B7 8B STA   @>22F9
     22
     F9
F9BA 8E CALL  @>FA87
     FA
     87
F9BD 98 MOVD  R73,R75
     49
     4B
F9C0 A2 MOVP  %>00,P15
     00
     0F
F9C3 A7 BTJZP %>02,P15,05   [F9CC]
     02
     0F
     05
F9C7 22 MOV   %>27,A
     27
F9C9 8C BR    @>FAA2
     FA
     A2

F9CC A7 BTJZP %>01,P15,0C   [F9DC]
     01
     0F
     0C
F9D0 A4 ORP   %>01,P15
     01
     0F
F9D3 B0 CLRC
F9D4 A3 ANDP  %>FE,P15
     FE
     0F
F9D7 B0 CLRC
F9D8 A6 BTJOP %>01,P15,EB   [F9C7]
     01
     0F
     EB
F9DC A2 MOVP  %>02,P15
     02
     0F
F9DF A2 MOVP  %>FF,P2
     FF
     02
F9E2 A2 MOVP  %>1F,P3
     1F
     03
F9E5 A2 MOVP  %>8C,P0
     8C
     00
F9E8 22 MOV   %>8C,A         Change code executed on INT 2 to BR @>FA99
     8C                      
F9EA 8B STA   @>209B         
     20                      
     9B                      
F9ED 88 MOVD  %>FA99,R1      
     FA                      
     99                      
     01                      
F9F1 8B STA   @>209C         
     20                      
     9C                      
F9F4 62 MOV   B,A            
F9F5 8B STA   @>209D         
     20                      
     9D                     
F9F8 05 EINT
F9F9 98 MOVD  R73,R77
     49
     4D
F9FC 88 MOVD  %>0009,R79
     00
     09
     4F
FA00 8E CALL  @>FACD
     FA
     CD
FA03 7A SUB   %>0A,R73
     0A
     49
FA06 7B SBB   %>00,R72
     00
     48
FA09 8E CALL  @>FA91
     FA
     91
FA0C 98 MOVD  R1,R77
     01
     4D
FA0F 98 MOVD  R77,R65
     4D
     41
FA12 78 ADD   %>04,R73
     04
     49
FA15 79 ADC   %>00,R72
     00
     48
FA18 98 MOVD  R73,R67
     49
     43
FA1B 8E CALL  @>FA91
     FA
     91
FA1E 98 MOVD  R1,R79
     01
     4F
FA21 8E CALL  @>FACD
     FA
     CD
FA24 98 MOVD  R67,R73
     43
     49
FA27 98 MOVD  R73,R77
     49
     4D
FA2A 88 MOVD  %>0002,R79
     00
     02
     4F
FA2E 8E CALL  @>FABD
     FA
     BD
FA31 78 ADD   %>03,R77
     03
     4D
FA34 79 ADC   %>00,R76
     00
     4C
FA37 DB DECD  R67
     43
FA39 9A LDA   *R77
     4D
FA3B 9D CMPA  *R67
     43
FA3D E7 JL    12            [FA51]
     12
FA3F E6 JNE   14            [FA55]
     14
FA41 D3 INC   R77
     4D
FA43 79 ADC   %>00,R76
     00
     4C
FA46 D3 INC   R67
     43
FA48 79 ADC   %>00,R66
     00
     42
FA4B 9A LDA   *R77
     4D
FA4D 9D CMPA  *R67
     43
FA4F E3 JHS   04            [FA55]
     04
FA51 22 MOV   %>0C,A
     0C
FA53 E0 JMP   4D            [FAA2]
     4D

FA55 8E CALL  @>FA91
     FA
     91
FA58 98 MOVD  R1,R79
     01
     4F
FA5B 98 MOVD  R65,R77
     41
     4D
FA5E 8E CALL  @>FABD
     FA
     BD
FA61 DB DECD  R73
     49
FA63 98 MOVD  R73,R77
     49
     4D
FA66 88 MOVD  %>0001,R79
     00
     01
     4F
FA6A 8E CALL  @>FABD
     FA
     BD
FA6D 06 DINT
FA6E A2 MOVP  %>AA,P0
     AA
     00
FA71 A2 MOVP  %>00,P15
     00
     0F
FA74 8A LDA   @>22F8
     22
     F8
FA77 27 BTJZ  %>01,A,08     [FA82]
     01
     08
FA7A A4 ORP   %>01,P15
     01
     0F
FA7D 8A LDA   @>22F9
     22
     F9
FA80 82 MOVP  A,P14
     0E
FA82 73 AND   %>DF,R49      Reset flag 77
     DF
     31
FA85 E0 JMP   03            [FA8A]
     03

FA87 74 OR    %>20,R49      Set flag 77
     20
     31
FA8A 88 MOVD  %>0256,R1     SBA 256
     02                     Update the indicators
     56
     01
FA8E 8C BR    @>F32F
     F3
     2F

FA91 9A LDA   *R73
     49
FA93 C0 MOV   A,B
FA94 DB DECD  R73
     49
FA96 9A LDA   *R73
     49
FA98 0A RETS

FA99 A2 MOVP  %>1F,P3       Stop the timer
     1F
     03
FA9C 09 STSP
FA9D 5A SUB   %>07,B        Remove interrupt and two returns
     07
FA9F 0D LDSP
FAA0 22 MOV   %>FF,A        255, device timeout error
     FF
FAA2 7A SUB   %>09,R75       Set pointer to statusbyte
     09                        in PAB
     4B                      
FAA5 7B SBB   %>00,R74       
     00                      
     4A                     
FAA8 9B STA   *R75          Store status in PAB
     4B
FAAA 98 MOVD  R75,R73       Set PAB pointer to status
     4B
     49
FAAD E0 JMP   BE            [FA6D]
     BE

FAAF 8E CALL  @>FAD2        Receive LSN
     FA
     D2
FAB2 62 MOV   B,A
FAB3 B7 SWAP  A
FAB4 8E CALL  @>FAD2        Receive MSN
     FA
     D2
FAB7 64 OR    B,A           Combine
FAB8 B7 SWAP  A
FAB9 9B STA   *R77          store in databuffer
     4D
FABB DB DECD  R77
     4D
FABD DB DECD  R79
     4F
FABF E3 JC    EE            [FAAF]
     EE
FAC1 0A RETS

FAC2 9A LDA   *R77          Get byte from databuffer
     4D
FAC4 8E CALL  @>FAEF        Send LSN
     FA
     EF
FAC7 B7 SWAP  A
FAC8 8E CALL  @>FAEF        Send MSN
     FA
     EF
FACB DB DECD  R77
     4D
FACD DB DECD  R79
     4F
FACF E3 JC    F1            [FAC2]
     F1
FAD1 0A RETS

Master receive routine

FAD2 A6 BTJOP %>08,P15,0E   [FAE4] IRQ active? (HSK toggled low)
     08
     0F
     0E
FAD6 A6 BTJOP %>01,P15,F8   [FAD2] If not, check if HSK is still low
     01
     0F
     F8
FADA A2 MOVP  %>9F,P3       If not, start timer for timeout
     9F
     03
FADD A7 BTJZP %>08,P15,FC   [FADD] Wait 20 ms for HSK low
     08
     0F
     FC
FAE1 A2 MOVP  %>1F,P3       HSK went low before timeout
     1F
     03
FAE4 A4 ORP   %>01,P15      Hold HSK low (clears IRQ)
     01
     0F
FAE7 91 MOVP  P14,B         Read the LSN of the databyte
     0E
FAE9 53 AND   %>0F,B        Clean of upper any nibble garbage
     0F
FAEB A3 ANDP  %>FE,P15      Release HSK signal
     FE
     0F
FAEE 0A RETS

Master transmit routine

FAEF A6 BTJOP %>01,P15,FC   [FAEF] Wait for HSK high
     01
     0F
     FC
FAF3 82 MOVP  A,P14         Send the LSN of the data byte
     0E
FAF5 A4 ORP   %>01,P15      Lower HSK
     01
     0F
FAF8 B0 CLRC                 Delay for bus timing
FAF9 00 NOP                 
FAFA A3 ANDP  %>FE,P15      Release HSK
     FE
     0F
FAFD 0A RETS

FAFE A2 MOVP  %>78,P2
     78
     02
FB01 E0 JMP   14            [FB17]
     14

SBA 49F
Enable the cassette motor

FB03 A2 MOVP  %>01,P15
     01
     0F
FB06 A2 MOVP  %>05,P14
     05
     0E
FB09 E0 JMP   06            [FB11]
     06

SBA 4A2
Disable the cassette motor

FB0B A2 MOVP  %>01,P15
     01
     0F
FB0E A3 ANDP  %>0B,P14
     0B
     0E
FB11 8E CALL  @>FDAD
     FD
     AD
FB14 A2 MOVP  %>00,P2
     00
     02
FB17 73 AND   %>BF,R55
     BF
     37
FB1A 88 MOVD  %>0611,R1
     06
     11
     01
FB1E A2 MOVP  %>87,P3
     87
     03
FB21 05 EINT
FB22 01 IDLE
FB23 CB DECD  B
FB24 E3 JC    FC            [FB22]
     FC
FB26 A2 MOVP  %>00,P3
     00
     03
FB29 32 MOV   R65,B
     41
FB2B 92 MOVP  B,P2
     02
FB2D 0A RETS

SBA 4AB

FB2E 8E CALL  @>FDA8
     FD
     A8
FB31 72 MOV   %>58,R65
     58
     41
FB34 88 MOVD  %>FBEE,R71
     FB
     EE
     47
FB38 98 MOVD  R81,R1
     51
     01
FB3B D5 CLR   R74
     4A
FB3D CF RLC   B
FB3E BF RLC   A
FB3F DF RLC   R74
     4A
FB41 CF RLC   B
FB42 BF RLC   A
FB43 DF RLC   R74
     4A
FB45 D0 MOV   A,R75
     4B
FB47 CC RR    B
FB48 CC RR    B
FB49 D1 MOV   B,R66
     42
FB4B 8E CALL  @>FB03        SBA 49F
     FB                     Enable the cassette motor
     03
FB4E 7D CMP   %>84,R84
     84
     54
FB51 E6 JNE   03            [FB56]
     03
FB53 8E CALL  @>FAFE
     FA
     FE
FB56 88 MOVD  %>04AF,R73
     04
     AF
     49
FB5A A2 MOVP  %>80,P3
     80
     03
FB5D B5 CLR   A
FB5E 8E CALL  @>FDDA
     FD
     DA
FB61 DB DECD  R73
     49
FB63 E3 JC    F8            [FB5D]
     F8
FB65 8E CALL  @>FDCA
     FD
     CA
FB68 12 MOV   R80,A
     50
FB6A 8E CALL  @>FDD7
     FD
     D7
FB6D 12 MOV   R81,A
     51
FB6F 8E CALL  @>FDD7
     FD
     D7
FB72 12 MOV   R74,A
     4A
FB74 8E CALL  @>FDD7
     FD
     D7
FB77 12 MOV   R75,A
     4B
FB79 8E CALL  @>FDD7
     FD
     D7
FB7C 12 MOV   R66,A
     42
FB7E 8E CALL  @>FDD7
     FD
     D7
FB81 12 MOV   R84,A
     54
FB83 8E CALL  @>FDD7
     FD
     D7
FB86 12 MOV   R78,A
     4E
FB88 8E CALL  @>FDDA
     FD
     DA
FB8B 75 XOR   %>08,R55
     08
     37
FB8E 76 BTJO  %>08,R55,D3   [FB65]
     08
     37
     D3
FB92 98 MOVD  R83,R73
     53
     49
FB95 DB DECD  R75
     4B
FB97 E7 JNC   22            [FBBB]
     22
FB99 8E CALL  @>FDCA
     FD
     CA
FB9C 52 MOV   %>40,B
     40
FB9E 9A LDA   *R73
     49
FBA0 8E CALL  @>FDD7
     FD
     D7
FBA3 DB DECD  R73
     49
FBA5 CA DJNZ  B,F7          [FB9E]
     F7
FBA7 12 MOV   R78,A
     4E
FBA9 8E CALL  @>FDDA
     FD
     DA
FBAC 75 XOR   %>08,R55
     08
     37
FBAF 77 BTJZ  %>08,R55,E2   [FB95]
     08
     37
     E2
FBB3 78 ADD   %>40,R73
     40
     49
FBB6 79 ADC   %>00,R72
     00
     48
FBB9 E0 JMP   DE            [FB99]
     DE

FBBB 32 MOV   R66,B
     42
FBBD E2 JZ    22            [FBE1]
     22
FBBF 8E CALL  @>FDCA
     FD
     CA
FBC2 32 MOV   R66,B
     42
FBC4 9A LDA   *R73
     49
FBC6 8E CALL  @>FDD7
     FD
     D7
FBC9 DB DECD  R73
     49
FBCB CA DJNZ  B,F7          [FBC4]
     F7
FBCD 12 MOV   R78,A
     4E
FBCF 8E CALL  @>FDDA
     FD
     DA
FBD2 75 XOR   %>08,R55
     08
     37
FBD5 77 BTJZ  %>08,R55,08   [FBE1]
     08
     37
     08
FBD9 48 ADD   R66,R73
     42
     49
FBDC 79 ADC   %>00,R72
     00
     48
FBDF E0 JMP   DA            [FBBB]
     DA

FBE1 22 MOV   %>FF,A
     FF
FBE3 8E CALL  @>FDDA
     FD
     DA
FBE6 7D CMP   %>82,R84
     82
     54
FBE9 E6 JNE   03            [FBEE]
     03
FBEB 8E CALL  @>FAFE
     FA
     FE
FBEE 8E CALL  @>FB0B        SBA 4A2
     FB                     Disable the cassette motor
     0B
FBF1 06 DINT
FBF2 A3 ANDP  %>C8,P0
     C8
     00
FBF5 12 MOV   R84,A
     54
FBF7 0A RETS

SBA 4AE

FBF8 74 OR    %>20,R55
     20
     37
FBFB E0 JMP   02            [FBFF]
     02

SBA 4A8

FBFD D5 CLR   R55
     37
FBFF 8E CALL  @>FDA8
     FD
     A8
FC02 72 MOV   %>84,R65
     84
     41
FC05 8E CALL  @>FB03        SBA 49F
     FB                     Enable the cassette motor
     03
FC08 A2 MOVP  %>80,P3
     80
     03
FC0B 88 MOVD  %>FFFF,R78
     FF
     FF
     4E
FC0F E0 JMP   0C            [FC1D]
     0C

FC11 72 MOV   %>84,R65
     84
     41
FC14 DB DECD  R78
     4E
FC16 E3 JC    05            [FC1D]
     05
FC18 72 MOV   %>02,R84
     02
     54
FC1B E0 JMP   D1            [FBEE]
     D1

FC1D 73 AND   %>BF,R55
     BF
     37
FC20 88 MOVD  %>FC11,R71
     FC
     11
     47
FC24 05 EINT
FC25 32 MOV   R65,B
     41
FC27 92 MOVP  B,P2
     02
FC29 8E CALL  @>FE0A
     FE
     0A
FC2C 52 MOV   %>30,B
     30
FC2E 76 BTJO  %>04,R55,06   [FC38]
     04
     37
     06
FC32 76 BTJO  %>08,R55,02   [FC38]
     08
     37
     02
FC36 CE RL    B
FC37 CE RL    B
FC38 8E CALL  @>FE09
     FE
     09
FC3B E3 JC    D4            [FC11]
     D4
FC3D CA DJNZ  B,F9          [FC38]
     F9
FC3F A2 MOVP  %>FF,P2
     FF
     02
FC42 A2 MOVP  %>87,P3
     87
     03
FC45 74 OR    %>40,R55
     40
     37
FC48 52 MOV   %>08,B
     08
FC4A 8E CALL  @>FE43
     FE
     43
FC4D E7 JNC   FB            [FC4A]
     FB
FC4F CA DJNZ  B,F9          [FC4A]
     F9
FC51 73 AND   %>BF,R55
     BF
     37
FC54 91 MOVP  P2,B
     02
FC56 A2 MOVP  %>00,P3
     00
     03
FC59 C4 INV   B
FC5A CD RRC   B
FC5B 62 MOV   B,A
FC5C CD RRC   B
FC5D 68 ADD   B,A
FC5E 2D CMP   %>5E,A
     5E
FC60 E7 JL    AF            [FC11]
     AF
FC62 D0 MOV   A,R65
     41
FC64 82 MOVP  A,P2
     02
FC66 8E CALL  @>FE0A
     FE
     0A
FC69 8E CALL  @>FE09
     FE
     09
FC6C E7 JNC   FB            [FC69]
     FB
FC6E 52 MOV   %>07,B
     07
FC70 8E CALL  @>FE09
     FE
     09
FC73 E7 JNC   9C            [FC11]
     9C
FC75 CA DJNZ  B,F9          [FC70]
     F9
FC77 88 MOVD  %>FCB6,R71
     FC
     B6
     47
FC7B D5 CLR   R78
     4E
FC7D 76 BTJO  %>04,R55,7F   [FD00]
     04
     37
     7F
FC81 8E CALL  @>FDF9
     FD
     F9
FC84 C0 MOV   A,B
FC85 8E CALL  @>FDF9
     FD
     F9
FC88 B6 XCHB  A
FC89 98 MOVD  R1,R77
     01
     4D
FC8C 8E CALL  @>FDF9
     FD
     F9
FC8F C0 MOV   A,B
FC90 8E CALL  @>FDF9
     FD
     F9
FC93 B6 XCHB  A
FC94 98 MOVD  R1,R75
     01
     4B
FC97 8E CALL  @>FDF9
     FD
     F9
FC9A D0 MOV   A,R66
     42
FC9C 8E CALL  @>FDF9
     FD
     F9
FC9F D0 MOV   A,R84
     54
FCA1 32 MOV   R78,B
     4E
FCA3 8E CALL  @>FDF9
     FD
     F9
FCA6 6D CMP   B,A
FCA7 E2 JEQ   12            [FCBB]
     12
FCA9 75 XOR   %>08,R55
     08
     37
FCAC 76 BTJO  %>08,R55,4D   [FCFD]
     08
     37
     4D
FCB0 72 MOV   %>04,R84
     04
     54
FCB3 8C BR    @>FBEE
     FB
     EE

FCB6 72 MOV   %>02,R84
     02
     54
FCB9 E0 JMP   F8            [FCB3]
     F8

FCBB 76 BTJO  %>08,R55,07   [FCC6]
     08
     37
     07
FCBF 52 MOV   %>10,B
     10
FCC1 8E CALL  @>FDF9
     FD
     F9
FCC4 CA DJNZ  B,FB          [FCC1]
     FB
FCC6 73 AND   %>F7,R55
     F7
     37
FCC9 74 OR    %>04,R55
     04
     37
FCCC 4D CMP   R80,R76
     50
     4C
FCCF E7 JL    07            [FCD8]
     07
FCD1 E6 JNE   0F            [FCE2]
     0F
FCD3 4D CMP   R81,R77
     51
     4D
FCD6 E3 JHS   0A            [FCE2]
     0A
FCD8 98 MOVD  R77,R81
     4D
     51
FCDB 77 BTJZ  %>20,R55,03   [FCE2]
     20
     37
     03
FCDF 74 OR    %>10,R84
     10
     54
FCE2 98 MOVD  R81,R77
     51
     4D
FCE5 E6 JNZ   04            [FCEB]
     04
FCE7 12 MOV   R81,A
     51
FCE9 E2 JZ    57            [FD42]
     57
FCEB 98 MOVD  R83,R73
     53
     49
FCEE 7D CMP   %>84,R84
     84
     54
FCF1 E6 JNE   0A            [FCFD]
     0A
FCF3 77 BTJZ  %>20,R55,06   [FCFD]
     20
     37
     06
FCF7 72 MOV   %>05,R79
     05
     4F
FCFA 74 OR    %>02,R55
     02
     37
FCFD 8C BR    @>FC0B
     FC
     0B

FD00 73 AND   %>EF,R55
     EF
     37
FD03 52 MOV   %>40,B
     40
FD05 12 MOV   R74,A
     4A
FD07 E6 JNZ   08            [FD11]
     08
FD09 12 MOV   R75,A
     4B
FD0B E6 JNZ   04            [FD11]
     04
FD0D 32 MOV   R66,B
     42
FD0F E2 JZ    31            [FD42]
     31
FD11 D1 MOV   B,R67
     43
FD13 D1 MOV   B,R68
     44
FD15 12 MOV   R76,A
     4C
FD17 E6 JNZ   0B            [FD24]
     0B
FD19 4D CMP   R1,R77
     01
     4D
FD1C E3 JHS   06            [FD24]
     06
FD1E 42 MOV   R77,R67
     4D
     43
FD21 74 OR    %>10,R84
     10
     54
FD24 42 MOV   R67,R69
     43
     45
FD27 8E CALL  @>FDF9
     FD
     F9
FD2A 42 MOV   R67,R67
     43
     43
FD2D E2 JZ    21            [FD50]
     21
FD2F DB DECD  R77
     4D
FD31 77 BTJZ  %>20,R55,15   [FD4A]
     20
     37
     15
FD35 76 BTJO  %>02,R55,0B   [FD44]
     02
     37
     0B
FD39 9D CMPA  *R73
     49
FD3B E2 JEQ   0F            [FD4C]
     0F
FD3D 74 OR    %>10,R55
     10
     37
FD40 E0 JMP   0A            [FD4C]
     0A

FD42 E0 JMP   4B            [FD8F]
     4B

FD44 DA DJNZ  R79,03        [FD4A]
     4F
     03
FD47 73 AND   %>FD,R55
     FD
     37
FD4A 9B STA   *R73
     49
FD4C DB DECD  R73
     49
FD4E D2 DEC   R67
     43
FD50 CA DJNZ  B,D5          [FD27]
     D5
FD52 32 MOV   R78,B
     4E
FD54 8E CALL  @>FDF9
     FD
     F9
FD57 6D CMP   B,A
FD58 E2 JEQ   13            [FD6D]
     13
FD5A 75 XOR   %>08,R55
     08
     37
FD5D 76 BTJO  %>08,R55,03   [FD64]
     08
     37
     03
FD61 8C BR    @>FCB0
     FC
     B0

FD64 48 ADD   R69,R73
     45
     49
FD67 79 ADC   %>00,R72
     00
     48
FD6A 8C BR    @>FC0B
     FC
     0B

FD6D 76 BTJO  %>08,R55,09   [FD7A]
     08
     37
     09
FD71 32 MOV   R68,B
     44
FD73 58 ADD   %>0A,B
     0A
FD75 8E CALL  @>FDF9
     FD
     F9
FD78 CA DJNZ  B,FB          [FD75]
     FB
FD7A 76 BTJO  %>10,R55,1B   [FD99]
     10
     37
     1B
FD7E 73 AND   %>F7,R55
     F7
     37
FD81 DB DECD  R75
     4B
FD83 E7 JNC   0A            [FD8F]
     0A
FD85 E6 JNZ   E3            [FD6A]
     E3
FD87 32 MOV   R75,B
     4B
FD89 E6 JNZ   DF            [FD6A]
     DF
FD8B 32 MOV   R66,B
     42
FD8D E6 JNZ   DB            [FD6A]
     DB
FD8F 88 MOVD  %>FBEE,R71
     FB
     EE
     47
FD93 8E CALL  @>FDF9
     FD
     F9
FD96 8C BR    @>FBEE
     FB
     EE

FD99 72 MOV   %>03,R84
     03
     54
FD9C E0 JMP   F8            [FD96]
     F8

FD9E 76 BTJO  %>40,R55,01   [FDA3]
     40
     37
     01
FDA2 0B RETI
FDA3 32 MOV   R64,B
     40
FDA5 0D LDSP
FDA6 9C BR    *R71
     47

FDA8 09 STSP
FDA9 5A SUB   %>02,B
     02
FDAB D1 MOV   B,R64
     40
FDAD 73 AND   %>20,R55
     20
     37
FDB0 22 MOV   %>8C,A         Change code executed on INT 2 to BR @>FD9E
     8C                      
FDB2 8B STA   @>209B         
     20                      
     9B                      
FDB5 88 MOVD  %>FD9E,R1      
     FD                      
     9E                      
     01                      
FDB9 8B STA   @>209C         
     20                      
     9C                      
FDBC 62 MOV   B,A            
FDBD 8B STA   @>209D         
     20                      
     9D                     
FDC0 A2 MOVP  %>00,P3
     00
     03
FDC3 A2 MOVP  %>AA,P0
     AA
     00
FDC6 A4 ORP   %>0C,P0
     0C
     00
FDC9 0A RETS

FDCA 52 MOV   %>08,B
     08
FDCC B5 CLR   A
FDCD 8E CALL  @>FDDA
     FD
     DA
FDD0 CA DJNZ  B,FB          [FDCD]
     FB
FDD2 B4 INV   A
FDD3 D5 CLR   R78
     4E
FDD5 E0 JMP   03            [FDDA]
     03

FDD7 48 ADD   R0,R78
     00
     4E
FDDA C8 PUSH  B
FDDB 52 MOV   %>08,B
     08
FDDD 01 IDLE
FDDE 8E CALL  @>FDEC
     FD
     EC
FDE1 01 IDLE
FDE2 BE RL    A
FDE3 E7 JNC   03            [FDE8]
     03
FDE5 8E CALL  @>FDEC
     FD
     EC
FDE8 CA DJNZ  B,F3          [FDDD]
     F3
FDEA C9 POP   B
FDEB 0A RETS

FDEC 75 XOR   %>80,R55
     80
     37
FDEF E1 JN    04            [FDF5]
     04
FDF1 A2 MOVP  %>04,P14
     04
     0E
FDF4 0A RETS

FDF5 A2 MOVP  %>0C,P14
     0C
     0E
FDF8 0A RETS

FDF9 C8 PUSH  B
FDFA 52 MOV   %>08,B
     08
FDFC BF RLC   A
FDFD 8E CALL  @>FE09
     FE
     09
FE00 29 ADC   %>00,A
     00
FE02 CA DJNZ  B,F8          [FDFC]
     F8
FE04 48 ADD   R0,R78
     00
     4E
FE07 C9 POP   B
FE08 0A RETS

FE09 01 IDLE
FE0A 73 AND   %>FE,R55
     FE
     37
FE0D A6 BTJOP %>01,P14,06   [FE17]
     01
     0E
     06
FE11 76 BTJO  %>80,R55,06   [FE1B]
     80
     37
     06
FE15 E0 JMP   09            [FE20]
     09

FE17 76 BTJO  %>80,R55,05   [FE20]
     80
     37
     05
FE1B 75 XOR   %>80,R55
     80
     37
FE1E D3 INC   R55
     37
FE20 74 OR    %>40,R55
     40
     37
FE23 77 BTJZ  %>80,R55,06   [FE2D]
     80
     37
     06
FE27 A6 BTJOP %>01,P14,FC   [FE27]
     01
     0E
     FC
FE2B E0 JMP   05            [FE32]
     05

FE2D A7 BTJZP %>01,P14,FC   [FE2D]
     01
     0E
     FC
FE31 00 NOP
FE32 A2 MOVP  %>80,P3
     80
     03
FE35 A4 ORP   %>08,P0
     08
     00
FE38 73 AND   %>BF,R55
     BF
     37
FE3B 75 XOR   %>80,R55
     80
     37
FE3E DC RR    R55
     37
FE40 DE RL    R55
     37
FE42 0A RETS

FE43 A6 BTJOP %>01,P14,09   [FE50]
     01
     0E
     09
FE47 77 BTJZ  %>80,R55,04   [FE4F]
     80
     37
     04
FE4B 75 XOR   %>80,R55
     80
     37
FE4E 07 SETC
FE4F 0A RETS

FE50 77 BTJZ  %>80,R55,F7   [FE4B]
     80
     37
     F7
FE54 0A RETS

SBA 469
This SBA is used to search for a label

Input:
R72   : first character of label
R73   : second character of label
R74/75: end address of search area
R76/77: starting address of search area
>2105 : errorcode, to be used if a label has not been found

Output:
Label not found: R76   : >00
Label found    : R76/77: Address of first byte after the label

FE55 9A LDA   *R77          Load programcode
     4D
FE57 2D CMP   %>FF,A        Compare with LBL
     FF
FE59 E2 JEQ   32            [FE8D] LBL?, compare characters after it
     32
FE5B 2D CMP   %>F9,A        Compare with GTO. All intructions starting at GTO
     F9                     allow hexadecimal addresses that can be confused
                            with LBL
FE5D E3 JHS   16            [FE75]
     16
FE5F 8E CALL  @>FE64        Increment PC and fetch code at new PC
     FE
     64
FE62 E0 JMP   F3            [FE57]
     F3

The following routine increments the search PC and fetches the code at the new
PC. If the end of the search area is reached and >2105 contains a non-zero
value, an error is generated. If >2105 contains 0, R76 is cleared to indicate
that the requested label has not been found.

FE64 D3 INC   R77
     4D
FE66 79 ADC   %>00,R76
     00
     4C
FE69 98 MOVD  R77,R1
     4D
     01
FE6C 3A SUB   R75,B
     4B
FE6E 1B SBB   R74,A
     4A
FE70 E3 JC    35            [FEA7] No carry indicates that the end of the
     35                            searcharea has been reached.
FE72 9A LDA   *R77
     4D
FE74 0A RETS

FE75 2D CMP   %>FB,A        Compare with DFA
     FB
FE77 E2 JEQ   0C            [FE85]
     0C
FE79 8E CALL  @>FE64
     FE
     64
FE7C 2D CMP   %>F8,A        Compare with IND
     F8
FE7E E2 JEQ   DF            [FE5F]
     DF
FE80 8E CALL  @>FE64
     FE
     64
FE83 E0 JMP   DA            [FE5F]
     DA

FE85 78 ADD   %>06,R77
     06
     4D
FE88 79 ADC   %>00,R76
     00
     4C
FE8B E0 JMP   D2            [FE5F]
     D2

FE8D 12 MOV   R73,A
     49
FE8F 14 OR    R72,A
     48
FE91 E2 JZ    13            [FEA6]
     13
FE93 8E CALL  @>FE64
     FE
     64
FE96 1D CMP   R72,A         First character after the label
     48
FE98 E6 JNE   E6            [FE80]
     E6
FE9A 8E CALL  @>FE64
     FE
     64
FE9D 1D CMP   R73,A         Second character after the label
     49
FE9F E6 JNE   BE            [FE5F]
     BE
FEA1 D3 INC   R77            Set the search PC to the address of the first
     4D                        instruction after the label
FEA3 79 ADC   %>00,R76       
     00                      
     4C                     
FEA6 0A RETS

FEA7 8A LDA   @>2105        Errorcode
     21
     05
FEAA F9 TRAP6

FEAB 09 STSP                 Remove a returnaddress from the stack
FEAC 5A SUB   %>02,B         
     02                      
FEAE 0D LDSP                
FEAF D5 CLR   R76           Label not found indicator
     4C
FEB1 0A RETS

SBA 46C
Insert a NOP at the current PC and shift all instructions down one byte.

FEB2 98 MOVD  R119,R65      Create a working copy of the PC
     77
     41
FEB5 C5 CLR   B             NOP
FEB6 9A LDA   *R65          Get code at PC
     41
FEB8 B6 XCHB  A             Exchange with previous
FEB9 9B STA   *R65          Store at PC
     41
FEBB D3 INC   R65
     41
FEBD 79 ADC   %>00,R64
     00
     40
FEC0 4D CMP   R117,R65      MSB of max PC
     75
     41
FEC3 E6 JNE   F1            [FEB6] Continue if MSB of working copy < MSB of
     F1                            max PC
FEC5 4D CMP   R116,R64      LSB of max PC
     74
     40
FEC8 E6 JNE   EC            [FEB6] Continue if LSB of working copy < LSB of
     EC                            max PC
FECA 0A RETS

SBA 46F
Delete the current instruction, move all instuctions following it down and
store NOPs at the end of the programmemory.

FECB 98 MOVD  R119,R65      First working copy of PC
     77
     41
FECE 98 MOVD  R119,R67      Second working copy of PC
     77
     43
FED1 48 ADD   R79,R67       Add length of instruction at PC to LSB of
     4F                     working copy
     43
FED4 79 ADC   %>00,R66      Correct MSB of working copy
     00
     42
FED7 E0 JMP   0E            [FEE7]
     0E

FED9 9A LDA   *R67
     43
FEDB 9B STA   *R65
     41
FEDD D3 INC   R65
     41
FEDF 79 ADC   %>00,R64
     00
     40
FEE2 D3 INC   R67
     43
FEE4 79 ADC   %>00,R66
     00
     42
FEE7 4D CMP   R117,R67      MSB of max PC
     75
     43
FEEA E6 JNE   ED            [FED9]
     ED
FEEC 4D CMP   R116,R66      LSB of max PC
     74
     42
FEEF E6 JNE   E8            [FED9]
     E8
FEF1 B5 CLR   A             NOP
FEF2 9B STA   *R65           Fill the bytes at the end of the program
     41                        memory with as many NOPs as the length of
FEF4 D3 INC   R65              the deleted instruction
     41                      
FEF6 79 ADC   %>00,R64       
     00                      
     40                      
FEF9 DA DJNZ  R79,F6          [FEF2]
     4F                      
     F6                     
FEFC 0A RETS

SBA 49C
Load the mnemonic of the instructioncode in R69

FEFD 12 MOV   R69,A
     45
FEFF 2C MPY   %>06,A
     06
FF01 88 MOVD  %>C185,R90
     C1
     85
     5A
FF05 48 ADD   R1,R90
     01
     5A
FF08 49 ADC   R0,R89
     00
     59
FF0B A3 ANDP  %>FC,P6
     FC
     06
FF0E 52 MOV   %>03,B
     03
FF10 9A LDA   *R90
     5A
FF12 AB STA   @>005F(B)
     00
     5F
FF15 DB DECD  R90
     5A
FF17 CA DJNZ  B,F7          [FF10]
     F7
FF19 0A RETS

SBA 457
This SBA check if the RUN PC is in range. If it is, it fetches the code at the
RUN PC and the RUN PC is incremented. It is isn't, flag 71 is set to indicate
an error.

FF1A 73 AND   %>7F,R48      Reset flag 71
     7F
     30
FF1D 98 MOVD  R119,R1       Move RUN PC to A/B
     77                     [R118: MSB, R119: LSB]
     01
FF20 3A SUB   R117,B         Subtract MAX PC from RUN PC
     75                      
FF22 1B SBB   R116,A         
     74                     
FF24 E3 JC    11            [FF37] Carry indicates RUN PC >= MAX PC
     11
FF26 98 MOVD  R119,R1       Move RUN PC to A/B
     77
     01
FF29 3A SUB   R115,B         Subtract MIN PC from RUN PC
     73                      
FF2B 1B SBB   R114,A         
     72                     
FF2D E7 JNC   08            [FF37] No carry indicates RUN PC < MIN PC
     08
FF2F 9A LDA   *R119         Load the code at the current RUN PC
     77
FF31 D3 INC   R119           Increment RUN PC
     77                      
FF33 79 ADC   %>00,R118      
     00                      
     76                     
FF36 0A RETS

FF37 74 OR    %>80,R48      Set flag 71, to indicate RUN PC out of range
     80
     30
FF3A 0A RETS

SBA 493
Start the timer and wait for an interrupt

Input:
A: Timer control information
B: Interrupt mask

FF3B 92 MOVP  B,P0
     00
FF3D 82 MOVP  A,P3
     03
FF3F 05 EINT
FF40 01 IDLE
FF41 06 DINT
FF42 0A RETS

SBA 45A
This SBA is used to scan for (a) specific key(s)

Input:
A : Row(s) to be scanned
B : Column(s) to be scanned

Output:
ST: 0: Specified key(s) was (were) not pressed
    1: Specified key(s) was (were) pressed

FF43 A3 ANDP  %>DF,P24      Disable the TMS 70C46 databus, and use it as
     DF                     general purpose I/O port
     18
FF46 A2 MOVP  %>FF,P13
     FF
     0D
FF49 92 MOVP  B,P12         Column selector
     0C
FF4B 86 BTJOP A,P4,00       [FF4E]
     04
     00
FF4E 0E PUSHST
FF4F A4 ORP   %>20,P24      Re-enable the databus
     20
     18
FF52 08 POPST
FF53 0A RETS

SBA 484
This SBA is used to scan (a) specific column(s) of the keyboard

Input:
B: Column(s) to be scanned

Output:
A: Row(s) that have a key pressed

FF54 A3 ANDP  %>DF,P24      Disable the TMS 70C46 databus, and use it as
     DF                     general purpose I/O port
     18
FF57 A2 MOVP  %>FF,P13
     FF
     0D
FF5A 92 MOVP  B,P12         Column sector
     0C
FF5C 80 MOVP  P4,A          Get rows
     04
FF5E A4 ORP   %>20,P24      Re-enable the databus
     20
     18
FF61 B0 CLRC                Set status bits on value in A
FF62 0A RETS

TRAP 3

FF63 A2 MOVP  %>00,P3
     00
     03

TRAP 1

FF66 A2 MOVP  %>AA,P0
     AA
     00
FF69 0B RETI

SBA 4A5

FF6A 91 MOVP  P6,B
     06
FF6C A4 ORP   %>01,P6
     01
     06
FF6F A4 ORP   %>02,P0
     02
     00
FF72 A3 ANDP  %>FE,P6
     FE
     06
FF75 76 BTJO  %>10,R49,1A   [FF93] Test if flag 76 is set
     10
     31
     1A
FF79 A6 BTJOP %>02,P0,1F    [FF9C]
     02
     00
     1F
FF7D 74 OR    %>10,R49      Set flag 76
     10
     31
FF80 92 MOVP  B,P6
     06
FF82 74 OR    %>20,R49      Set flag 77
     20
     31
FF85 A6 BTJOP %>03,P15,03   [FF8C]
     03
     0F
     03
FF89 73 AND   %>DF,R49      Reset flag 77
     DF
     31
FF8C 88 MOVD  %>0256,R1     SBA 256
     02                     Update the indicators
     56
     01
FF90 8C BR    @>F32F
     F3
     2F

FF93 A7 BTJZP %>02,P0,05    [FF9C]
     02
     00
     05
FF97 73 AND   %>EF,R49      Reset flag 76
     EF
     31
FF9A E0 JMP   E4            [FF80]
     E4

FF9C 92 MOVP  B,P6
     06
FF9E 76 BTJO  %>20,R49,05   [FFA7] Test if flag 77 is set
     20
     31
     05
FFA2 A6 BTJOP %>03,P15,DC   [FF82]
     03
     0F
     DC
FFA6 0A RETS

FFA7 A6 BTJOP %>03,P15,FB   [FFA6]
     03
     0F
     FB
FFAB E0 JMP   DC            [FF89]
     DC

SBA 478/TRAP 6
This SBA/TRAP processes errors

FFAD B0 CLRC
FFAE E2 JZ    16            [FFC6] Is errorcode 0?, RETS
     16
FFB0 D0 MOV   A,R111        Errorcode
     6F
FFB2 F3 TRAP12              Reset flags 35, 37, 38 and 59
FFB3 88 MOVD  %>2067,R113   Delete floating point stack
     20
     67
     71
FFB7 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
FFBA 52 MOV   %>01,B         Delete TMS 70C46 stack
     01                      
FFBC 0D LDSP                
FFBD 8C BR    @>F211
     F2
     11

TRAP 12

FFC0 73 AND   %>97,R44      Reset flags 35, 37 and 38
     97
     2C
FFC3 73 AND   %>F7,R47      Reset flag 59
     F7
     2F
FFC6 0A RETS

FFC7 FF
FFC8 FF
FFC9 FF
FFCA FF
FFCB FF
FFCC FF
FFCD FF
FFCE FF
FFCF FF

Traptable

Note: Default page for traps 18 - 23 is page 3.

FFD0 C0   23  [C00F] This TRAP is not used
     0F

FFD2 C0   22  [C00C] Page 1: Not used
     0C                   2: Send data at >22BE to the LCD controller
                          3: Not used

FFD4 C0   21  [C009] Page 1: Not used
     09                   2: Send command at >22BF to the LCD controller
                          3: Clear SR 2009

FFD6 C0   20  [C006] Page 1: Get information out of the directory of File Space
     06                   2: Reset flags 35, 37, 38, 56, 61 and 62
                          3: Store a character in the PD buffer

FFD8 C0   19  [C003] Page 1: Shift the system alpha register
     03                   2: ?
                          3: Execute SBA 43F (Convert STD to FP)

FFDA C0   18  [C000] Page 1: Put information in the directory of File Space
     00                   2: Store a character in the PD buffer
                          3: Check field of field instruction

FFDC F7   17  [F77E] SR 2012:= SR 2009 / SR 2012
     7E

FFDE F5   16  [F5BD] SR 2012:= SR 2009 + SR 2012
     BD

FFE0 F3   15  [F34A] Call routine, address in R70/71, and return to
     4A              calling syspage

FFE2 F6   14  [F68E] SR 2012:= SR 2009 * SR 2012
     8E

FFE4 20   13  [20A7] Soft trap, not used
     A7

FFE6 FF   12  [FFC0] Reset flags 35 (AOS), 37 (HYP), 38 (INV) and 59 (INS)
     C0

FFEA F9   11  [F922] Pop FP stack into SR 2009
     22

FFE8 F8   10  [F8C2] Push SR 2012 onto FP stack
     C2

FFEC F8    9  [F8A3] Move 8 bytes pointed to by R70/71 into SR 2009
     A3              (R70/71 are decremented)

FFEE F9    8  [F98B] Move a block
     8B              Source     : R80/81
                     Destination: R82/83
                     # of bytes : R84/85

FFF0 F3    7  [F32F] Execute SBA nxx, n in A and xx in B
     2F

FFF2 20    6  [20A4] Errormessage, errorcode in A  (Soft trap!)
     A4

FFF4 20    5  [20A1] Soft trap, not used
     A1

FFF6 20    4  [209E] Soft trap, not used
     9E

FFF8 FF    3  [FF63] Interrupt 3
     63

FFFA 20    2  [209B] Timer 1 (Soft interrupt)
     9B

FFFC FF    1  [FF66] Interrupt 1 [Low battery ?]
     66

FFFE F0    0  [F0FA] Reset (ON)
     FA